package org.josast.influxdb;

import java.util.concurrent.TimeUnit;

import org.influxdb.InfluxDB;
import org.influxdb.InfluxDBFactory;
import org.influxdb.dto.BatchPoints;
import org.influxdb.dto.Point;
import org.influxdb.dto.Pong;

public abstract class AbstractInflux {

	 public String databasename = null;
	 public InfluxDB influxDB=null; 

	public void conect (String databaseURL, String userName,String password )
	{
		influxDB = InfluxDBFactory.connect( databaseURL, userName, password);
		Pong response =  influxDB.ping();
		if (response.getVersion().equalsIgnoreCase("unknown")) {
			System.out.println("Error pinging server.");
		} else {
			System.out.println(response.getVersion());
		}
	}
	
	public void createDataBase(String database)
	{


		if (influxDB.databaseExists(database)==false) {
		System.out.println("new database");
		influxDB.createDatabase(database);
		} 
		System.out.println("database exist");
		databasename=database ;
	}
	
	public void storeSid(int sid, String source, long time)
	{
	BatchPoints batchPoints = BatchPoints
				  .database(databasename)
				  .build();
	Point point0 = Point.measurement("sid") 
	.time(System.currentTimeMillis(), TimeUnit.MILLISECONDS) 
	.addField("value", sid )
	.addField("Source", source )
	.addField("timFrame",time)
	.build();

	batchPoints.point(point0);
    influxDB.write(batchPoints);
	}

}
