// This is a generated file! Please edit source .ksy file and use kaitai-struct-compiler to rebuild

package org.josast.uvsqsat.generated;

import io.kaitai.struct.ByteBufferKaitaiStream;
import io.kaitai.struct.KaitaiStruct;
import io.kaitai.struct.KaitaiStream;
import java.io.IOException;
import java.nio.charset.Charset;


/**
 * : UVSQsat telemetry description file 
 * : Version 0.2.8
 * :
 * : reference documentation 
 * :      UVSQsat-Beacon description for web site 
 * :  
 * : This ksy file is used for different automatic code generation 
 * :    - ksy file to programming language thanks o ksy compiler 
 *      - ksy file to graphwiz document thnaks to ksy compiler 
 *      - Ksy file to java textual display files thanks to JOSAST GeneratePOJOfromKSY tool (experimental)
 *      - Ksy file to FXML files and associated java files file thanks to JOSAST GeneratePOJOfromKSY tool (experimental)
 *      
 * : Writing rules should be respected (see JOSAST project)
 * :   - for interpreted value, variable should finish with 
 * :      _raw if no interpretation is done 
 * :      _c, _ma _v _dbm _mw according to the interpreted value 
 * :   - the name of the interpreted value should be close to the displaed name (to limit rework)
 * :      _c, _ma _v _dbm _mw are automaticaly converted to (C) (mA) (dbm) (mW)
 * :
 * :field dest_callsign: ax25_frame.ax25_header.dest_callsign_raw.callsign_ror.callsign
 * :field src_callsign: ax25_frame.ax25_header.src_callsign_raw.callsign_ror.callsign
 * :field src_ssid: ax25_frame.ax25_header.src_ssid_raw.ssid
 * :field dest_ssid: ax25_frame.ax25_header.dest_ssid_raw.ssid
 * :field ctl: ax25_frame.ax25_header.ctl
 * :field pid: ax25_frame.payload.pid
 */
public class Uvsqsat extends KaitaiStruct {
    public static Uvsqsat fromFile(String fileName) throws IOException {
        return new Uvsqsat(new ByteBufferKaitaiStream(fileName));
    }

    public Uvsqsat(KaitaiStream _io) {
        this(_io, null, null);
    }

    public Uvsqsat(KaitaiStream _io, KaitaiStruct _parent) {
        this(_io, _parent, null);
    }

    public Uvsqsat(KaitaiStream _io, KaitaiStruct _parent, Uvsqsat _root) {
        super(_io);
        this._parent = _parent;
        this._root = _root == null ? this : _root;
        _read();
    }
    private void _read() {
        this.ax25Frame = new Ax25Frame(this._io, this, _root);
    }
    public static class Ax25Frame extends KaitaiStruct {
        public static Ax25Frame fromFile(String fileName) throws IOException {
            return new Ax25Frame(new ByteBufferKaitaiStream(fileName));
        }

        public Ax25Frame(KaitaiStream _io) {
            this(_io, null, null);
        }

        public Ax25Frame(KaitaiStream _io, Uvsqsat _parent) {
            this(_io, _parent, null);
        }

        public Ax25Frame(KaitaiStream _io, Uvsqsat _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.ax25Header = new Ax25Header(this._io, this, _root);
            switch ((ax25Header().ctl() & 19)) {
            case 0: {
                this.payload = new IFrame(this._io, this, _root);
                break;
            }
            case 3: {
                this.payload = new UiFrame(this._io, this, _root);
                break;
            }
            case 19: {
                this.payload = new UiFrame(this._io, this, _root);
                break;
            }
            case 16: {
                this.payload = new IFrame(this._io, this, _root);
                break;
            }
            case 18: {
                this.payload = new IFrame(this._io, this, _root);
                break;
            }
            case 2: {
                this.payload = new IFrame(this._io, this, _root);
                break;
            }
            default: {
                this.payload = new IFrame(this._io, this, _root);
                break;
            }
            }
        }
        private Ax25Header ax25Header;
        private KaitaiStruct payload;
        private Uvsqsat _root;
        private Uvsqsat _parent;
        public Ax25Header ax25Header() { return ax25Header; }
        public KaitaiStruct payload() { return payload; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat _parent() { return _parent; }
    }
    public static class Ax25Header extends KaitaiStruct {
        public static Ax25Header fromFile(String fileName) throws IOException {
            return new Ax25Header(new ByteBufferKaitaiStream(fileName));
        }

        public Ax25Header(KaitaiStream _io) {
            this(_io, null, null);
        }

        public Ax25Header(KaitaiStream _io, Uvsqsat.Ax25Frame _parent) {
            this(_io, _parent, null);
        }

        public Ax25Header(KaitaiStream _io, Uvsqsat.Ax25Frame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.destCallsignRaw = new CallsignRaw(this._io, this, _root);
            this.destSsidRaw = new SsidMask(this._io, this, _root);
            this.srcCallsignRaw = new CallsignRaw(this._io, this, _root);
            this.srcSsidRaw = new SsidMask(this._io, this, _root);
            this.ctl = this._io.readU1();
        }
        private CallsignRaw destCallsignRaw;
        private SsidMask destSsidRaw;
        private CallsignRaw srcCallsignRaw;
        private SsidMask srcSsidRaw;
        private int ctl;
        private Uvsqsat _root;
        private Uvsqsat.Ax25Frame _parent;
        public CallsignRaw destCallsignRaw() { return destCallsignRaw; }
        public SsidMask destSsidRaw() { return destSsidRaw; }
        public CallsignRaw srcCallsignRaw() { return srcCallsignRaw; }
        public SsidMask srcSsidRaw() { return srcSsidRaw; }
        public int ctl() { return ctl; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.Ax25Frame _parent() { return _parent; }
    }
    public static class UiFrame extends KaitaiStruct {
        public static UiFrame fromFile(String fileName) throws IOException {
            return new UiFrame(new ByteBufferKaitaiStream(fileName));
        }

        public UiFrame(KaitaiStream _io) {
            this(_io, null, null);
        }

        public UiFrame(KaitaiStream _io, Uvsqsat.Ax25Frame _parent) {
            this(_io, _parent, null);
        }

        public UiFrame(KaitaiStream _io, Uvsqsat.Ax25Frame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.pid = this._io.readU1();
            this.packetPrimaryHeader = new PacketPrimaryHeader(this._io, this, _root);
            this.packetSecondaryHeader = new PacketSecondaryHeader(this._io, this, _root);
            switch (packetSecondaryHeader().sid()) {
            case 14: {
                this.tlm = new AmsatAscii(this._io, this, _root);
                break;
            }
            case 17: {
                this.tlm = new ObcStatus(this._io, this, _root);
                break;
            }
            case 24: {
                this.tlm = new TrxvutxHk(this._io, this, _root);
                break;
            }
            case 20: {
                this.tlm = new MainboardHk(this._io, this, _root);
                break;
            }
            case 19: {
                this.tlm = new MainboardAllScience(this._io, this, _root);
                break;
            }
            case 23: {
                this.tlm = new ImtqHk(this._io, this, _root);
                break;
            }
            case 15: {
                this.tlm = new Beacon(this._io, this, _root);
                break;
            }
            case 21: {
                this.tlm = new IepsHkStatus(this._io, this, _root);
                break;
            }
            case 16: {
                this.tlm = new AntsHk(this._io, this, _root);
                break;
            }
            case 18: {
                this.tlm = new ObcHk(this._io, this, _root);
                break;
            }
            case 22: {
                this.tlm = new TrxvurxHk(this._io, this, _root);
                break;
            }
            default: {
                this.tlm = new MsgOrUnknow(this._io, this, _root);
                break;
            }
            }
            this.ax25Info = this._io.readBytesFull();
        }
        private int pid;
        private PacketPrimaryHeader packetPrimaryHeader;
        private PacketSecondaryHeader packetSecondaryHeader;
        private KaitaiStruct tlm;
        private byte[] ax25Info;
        private Uvsqsat _root;
        private Uvsqsat.Ax25Frame _parent;
        public int pid() { return pid; }
        public PacketPrimaryHeader packetPrimaryHeader() { return packetPrimaryHeader; }
        public PacketSecondaryHeader packetSecondaryHeader() { return packetSecondaryHeader; }
        public KaitaiStruct tlm() { return tlm; }
        public byte[] ax25Info() { return ax25Info; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.Ax25Frame _parent() { return _parent; }
    }
    public static class Callsign extends KaitaiStruct {
        public static Callsign fromFile(String fileName) throws IOException {
            return new Callsign(new ByteBufferKaitaiStream(fileName));
        }

        public Callsign(KaitaiStream _io) {
            this(_io, null, null);
        }

        public Callsign(KaitaiStream _io, Uvsqsat.CallsignRaw _parent) {
            this(_io, _parent, null);
        }

        public Callsign(KaitaiStream _io, Uvsqsat.CallsignRaw _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.callsign = new String(this._io.readBytes(6), Charset.forName("ASCII"));
        }
        private String callsign;
        private Uvsqsat _root;
        private Uvsqsat.CallsignRaw _parent;
        public String callsign() { return callsign; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.CallsignRaw _parent() { return _parent; }
    }
    public static class PacketPrimaryHeader extends KaitaiStruct {
        public static PacketPrimaryHeader fromFile(String fileName) throws IOException {
            return new PacketPrimaryHeader(new ByteBufferKaitaiStream(fileName));
        }

        public PacketPrimaryHeader(KaitaiStream _io) {
            this(_io, null, null);
        }

        public PacketPrimaryHeader(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public PacketPrimaryHeader(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.packetVersionNumber = this._io.readBitsInt(3);
            this.packetIdPacketType = this._io.readBitsInt(1) != 0;
            this.packetIdSecondaryHeaderFlag = this._io.readBitsInt(1) != 0;
            this.packetIdApplicationProcessId = this._io.readBitsInt(11);
            this.packetSequenceControlSecquenceFlag = this._io.readBitsInt(2);
            this.packetSequenceControlCountOrName = this._io.readBitsInt(14);
            this._io.alignToByte();
            this.packetDataLength = this._io.readU2be();
        }
        private long packetVersionNumber;
        private boolean packetIdPacketType;
        private boolean packetIdSecondaryHeaderFlag;
        private long packetIdApplicationProcessId;
        private long packetSequenceControlSecquenceFlag;
        private long packetSequenceControlCountOrName;
        private int packetDataLength;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long packetVersionNumber() { return packetVersionNumber; }
        public boolean packetIdPacketType() { return packetIdPacketType; }
        public boolean packetIdSecondaryHeaderFlag() { return packetIdSecondaryHeaderFlag; }
        public long packetIdApplicationProcessId() { return packetIdApplicationProcessId; }
        public long packetSequenceControlSecquenceFlag() { return packetSequenceControlSecquenceFlag; }
        public long packetSequenceControlCountOrName() { return packetSequenceControlCountOrName; }
        public int packetDataLength() { return packetDataLength; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class TrxvutxHk extends KaitaiStruct {
        public static TrxvutxHk fromFile(String fileName) throws IOException {
            return new TrxvutxHk(new ByteBufferKaitaiStream(fileName));
        }

        public TrxvutxHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public TrxvutxHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public TrxvutxHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPort = this._io.readBitsInt(12);
            this.trxvutxInstantaneousRfForwardPowerFromTransmitterPort = this._io.readBitsInt(12);
            this.trxvutxSupplyVoltage = this._io.readBitsInt(12);
            this.trxvutxTotalSupplyCurrent = this._io.readBitsInt(12);
            this.trxvutxTransmitterCurrent = this._io.readBitsInt(12);
            this.trxvutxReceiverCurrent = this._io.readBitsInt(12);
            this.trxvutxPowerAmplifierCurrent = this._io.readBitsInt(12);
            this.trxvutxPowerAmplifierTemperature = this._io.readBitsInt(12);
            this.trxvutxLocalOscillatorTemperature = this._io.readBitsInt(12);
            this.trxvutxZeroPadding = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.trxvuTxUptime = this._io.readU4be();
            this.trxvuTxState = this._io.readU1();
        }
        private Double trxvutxTotalSupplyCurrentMa;
        public Double trxvutxTotalSupplyCurrentMa() {
            if (this.trxvutxTotalSupplyCurrentMa != null)
                return this.trxvutxTotalSupplyCurrentMa;
            double _tmp = (double) ((0.16643964 * trxvutxTotalSupplyCurrent()));
            this.trxvutxTotalSupplyCurrentMa = _tmp;
            return this.trxvutxTotalSupplyCurrentMa;
        }
        private Double trxvutxPowerAmplifierCurrentMa;
        public Double trxvutxPowerAmplifierCurrentMa() {
            if (this.trxvutxPowerAmplifierCurrentMa != null)
                return this.trxvutxPowerAmplifierCurrentMa;
            double _tmp = (double) (((1000.0 * trxvutxPowerAmplifierCurrent()) * 0.16643964));
            this.trxvutxPowerAmplifierCurrentMa = _tmp;
            return this.trxvutxPowerAmplifierCurrentMa;
        }
        private Long trxvuTxUptimeRaw;
        public Long trxvuTxUptimeRaw() {
            if (this.trxvuTxUptimeRaw != null)
                return this.trxvuTxUptimeRaw;
            long _tmp = (long) (trxvuTxUptime());
            this.trxvuTxUptimeRaw = _tmp;
            return this.trxvuTxUptimeRaw;
        }
        private Double trxvutxSupplyVoltageV;
        public Double trxvutxSupplyVoltageV() {
            if (this.trxvutxSupplyVoltageV != null)
                return this.trxvutxSupplyVoltageV;
            double _tmp = (double) ((0.00488 * trxvutxSupplyVoltage()));
            this.trxvutxSupplyVoltageV = _tmp;
            return this.trxvutxSupplyVoltageV;
        }
        private Double trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
        public Double trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw() {
            if (this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw != null)
                return this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
            double _tmp = (double) (((((1000.0 * trxvutxInstantaneousRfReflectedPowerFromTransmitterPort()) * trxvutxInstantaneousRfReflectedPowerFromTransmitterPort()) * 5.887) * 0.00001));
            this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw = _tmp;
            return this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
        }
        private Double trxvutxLocalOscillatorTemperatureC;
        public Double trxvutxLocalOscillatorTemperatureC() {
            if (this.trxvutxLocalOscillatorTemperatureC != null)
                return this.trxvutxLocalOscillatorTemperatureC;
            double _tmp = (double) (((trxvutxLocalOscillatorTemperature() * -0.07669) + 195.6037));
            this.trxvutxLocalOscillatorTemperatureC = _tmp;
            return this.trxvutxLocalOscillatorTemperatureC;
        }
        private Double trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
        public Double trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw() {
            if (this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw != null)
                return this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
            double _tmp = (double) (((((1000.0 * trxvutxInstantaneousRfForwardPowerFromTransmitterPort()) * trxvutxInstantaneousRfForwardPowerFromTransmitterPort()) * 5.887) * 0.00001));
            this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw = _tmp;
            return this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
        }
        private Double trxvutxReceiverCurrentMa;
        public Double trxvutxReceiverCurrentMa() {
            if (this.trxvutxReceiverCurrentMa != null)
                return this.trxvutxReceiverCurrentMa;
            double _tmp = (double) ((trxvutxReceiverCurrent() * 0.16643964));
            this.trxvutxReceiverCurrentMa = _tmp;
            return this.trxvutxReceiverCurrentMa;
        }
        private Long trxvutxZeroPaddingRaw;
        public Long trxvutxZeroPaddingRaw() {
            if (this.trxvutxZeroPaddingRaw != null)
                return this.trxvutxZeroPaddingRaw;
            long _tmp = (long) (trxvutxZeroPadding());
            this.trxvutxZeroPaddingRaw = _tmp;
            return this.trxvutxZeroPaddingRaw;
        }
        private Double trxvutxPowerAmplifierTemperatureC;
        public Double trxvutxPowerAmplifierTemperatureC() {
            if (this.trxvutxPowerAmplifierTemperatureC != null)
                return this.trxvutxPowerAmplifierTemperatureC;
            double _tmp = (double) (((trxvutxPowerAmplifierTemperature() * -0.07669) + 195.6037));
            this.trxvutxPowerAmplifierTemperatureC = _tmp;
            return this.trxvutxPowerAmplifierTemperatureC;
        }
        private Double trxvutxTransmitterCurrentMa;
        public Double trxvutxTransmitterCurrentMa() {
            if (this.trxvutxTransmitterCurrentMa != null)
                return this.trxvutxTransmitterCurrentMa;
            double _tmp = (double) ((trxvutxTransmitterCurrent() * 0.16643964));
            this.trxvutxTransmitterCurrentMa = _tmp;
            return this.trxvutxTransmitterCurrentMa;
        }
        private Integer trxvuTxStateRaw;
        public Integer trxvuTxStateRaw() {
            if (this.trxvuTxStateRaw != null)
                return this.trxvuTxStateRaw;
            int _tmp = (int) (trxvuTxState());
            this.trxvuTxStateRaw = _tmp;
            return this.trxvuTxStateRaw;
        }
        private long trxvutxInstantaneousRfReflectedPowerFromTransmitterPort;
        private long trxvutxInstantaneousRfForwardPowerFromTransmitterPort;
        private long trxvutxSupplyVoltage;
        private long trxvutxTotalSupplyCurrent;
        private long trxvutxTransmitterCurrent;
        private long trxvutxReceiverCurrent;
        private long trxvutxPowerAmplifierCurrent;
        private long trxvutxPowerAmplifierTemperature;
        private long trxvutxLocalOscillatorTemperature;
        private long trxvutxZeroPadding;
        private long trxvuTxUptime;
        private int trxvuTxState;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long trxvutxInstantaneousRfReflectedPowerFromTransmitterPort() { return trxvutxInstantaneousRfReflectedPowerFromTransmitterPort; }
        public long trxvutxInstantaneousRfForwardPowerFromTransmitterPort() { return trxvutxInstantaneousRfForwardPowerFromTransmitterPort; }
        public long trxvutxSupplyVoltage() { return trxvutxSupplyVoltage; }
        public long trxvutxTotalSupplyCurrent() { return trxvutxTotalSupplyCurrent; }
        public long trxvutxTransmitterCurrent() { return trxvutxTransmitterCurrent; }
        public long trxvutxReceiverCurrent() { return trxvutxReceiverCurrent; }
        public long trxvutxPowerAmplifierCurrent() { return trxvutxPowerAmplifierCurrent; }
        public long trxvutxPowerAmplifierTemperature() { return trxvutxPowerAmplifierTemperature; }
        public long trxvutxLocalOscillatorTemperature() { return trxvutxLocalOscillatorTemperature; }
        public long trxvutxZeroPadding() { return trxvutxZeroPadding; }
        public long trxvuTxUptime() { return trxvuTxUptime; }
        public int trxvuTxState() { return trxvuTxState; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class MainboardAllScience extends KaitaiStruct {
        public static MainboardAllScience fromFile(String fileName) throws IOException {
            return new MainboardAllScience(new ByteBufferKaitaiStream(fileName));
        }

        public MainboardAllScience(KaitaiStream _io) {
            this(_io, null, null);
        }

        public MainboardAllScience(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public MainboardAllScience(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.mainboardScienceTime = this._io.readU4be();
            this.teachWearOn = this._io.readU1();
            this.frequenceOfAcquisitions = this._io.readU2be();
            this.gain = this._io.readU4be();
            this.numberOfAcquisitionCommanded = this._io.readU2be();
            this.numberOfRealAcquisition = this._io.readU2be();
            this.hkPlus5v = this._io.readU4be();
            this.hkMinus5v = this._io.readU4be();
            this.hkMinus5vPolar = this._io.readU4be();
            this.hkTempAdc = this._io.readU4be();
            this.hkFeePlusXVref = this._io.readU4be();
            this.hkFeeMinusXVref = this._io.readU4be();
            this.hkFeePlusYVref = this._io.readU4be();
            this.hkFeeMinusYVref = this._io.readU4be();
            this.feePlusXErs1Signal = this._io.readU4be();
            this.feePlusXErs1Temperature = this._io.readU4be();
            this.feePlusXErs2Signal = this._io.readU4be();
            this.feePlusXErs2Temperature = this._io.readU4be();
            this.feePlusXErs3Signal = this._io.readU4be();
            this.feePlusXErs3Temperature = this._io.readU4be();
            this.feePlusXUvsSignal = this._io.readU4be();
            this.feeMinusXErs1Signal = this._io.readU4be();
            this.feeMinusXErs1Temperature = this._io.readU4be();
            this.feeMinusXErs2Signal = this._io.readU4be();
            this.feeMinusXErs2Temperature = this._io.readU4be();
            this.feeMinusXErs3Signal = this._io.readU4be();
            this.feeMinusXErs3Temperature = this._io.readU4be();
            this.feeMinusXUvsSignal = this._io.readU4be();
            this.feePlusYErs1Signal = this._io.readU4be();
            this.feePlusYErs1Temperature = this._io.readU4be();
            this.feePlusYErs2Signal = this._io.readU4be();
            this.feePlusYErs2Temperature = this._io.readU4be();
            this.feePlusYErs3Signal = this._io.readU4be();
            this.feePlusYErs3Temperature = this._io.readU4be();
            this.feePlusYUvsSignal = this._io.readU4be();
            this.feeMinusYErs1Signal = this._io.readU4be();
            this.feeMinusYErs1Temperature = this._io.readU4be();
            this.feeMinusYErs2Signal = this._io.readU4be();
            this.feeMinusYErs2Temperature = this._io.readU4be();
            this.feeMinusYErs3Signal = this._io.readU4be();
            this.feeMinusYErs3Temperature = this._io.readU4be();
            this.feeMinusYUvsSignal = this._io.readU4be();
            this.teachwearAccX = this._io.readU2be();
            this.teachwearAccY = this._io.readU2be();
            this.teachwearAccZ = this._io.readU2be();
            this.teachwearDegC = this._io.readU2be();
            this.teachwearGyroX = this._io.readU2be();
            this.teachwearGyroY = this._io.readU2be();
            this.teachwearGyroZ = this._io.readU2be();
            this.teachwearMagnX = this._io.readU2be();
            this.teachwearMagnY = this._io.readU2be();
            this.teachwearMagnZ = this._io.readU2be();
            this.teachwearState = this._io.readU1();
            this.teachwearResetReason = this._io.readU1();
            this.teachwearCrc = this._io.readU2be();
            this.nbTmSinceFirstStart = this._io.readU4be();
        }
        private Long feePlusYErs1SignalRaw;
        public Long feePlusYErs1SignalRaw() {
            if (this.feePlusYErs1SignalRaw != null)
                return this.feePlusYErs1SignalRaw;
            long _tmp = (long) (feePlusYErs1Signal());
            this.feePlusYErs1SignalRaw = _tmp;
            return this.feePlusYErs1SignalRaw;
        }
        private Long feeMinusYErs1TemperatureRaw;
        public Long feeMinusYErs1TemperatureRaw() {
            if (this.feeMinusYErs1TemperatureRaw != null)
                return this.feeMinusYErs1TemperatureRaw;
            long _tmp = (long) (feeMinusYErs1Temperature());
            this.feeMinusYErs1TemperatureRaw = _tmp;
            return this.feeMinusYErs1TemperatureRaw;
        }
        private Integer teachwearCRCRaw;
        public Integer teachwearCRCRaw() {
            if (this.teachwearCRCRaw != null)
                return this.teachwearCRCRaw;
            int _tmp = (int) (teachwearCrc());
            this.teachwearCRCRaw = _tmp;
            return this.teachwearCRCRaw;
        }
        private Long feePlusXErs2SignalRaw;
        public Long feePlusXErs2SignalRaw() {
            if (this.feePlusXErs2SignalRaw != null)
                return this.feePlusXErs2SignalRaw;
            long _tmp = (long) (feePlusXErs2Signal());
            this.feePlusXErs2SignalRaw = _tmp;
            return this.feePlusXErs2SignalRaw;
        }
        private Long hkFeePlusXVrefRaw;
        public Long hkFeePlusXVrefRaw() {
            if (this.hkFeePlusXVrefRaw != null)
                return this.hkFeePlusXVrefRaw;
            long _tmp = (long) (hkFeePlusXVref());
            this.hkFeePlusXVrefRaw = _tmp;
            return this.hkFeePlusXVrefRaw;
        }
        private Long feeMinusYUvsSignalRaw;
        public Long feeMinusYUvsSignalRaw() {
            if (this.feeMinusYUvsSignalRaw != null)
                return this.feeMinusYUvsSignalRaw;
            long _tmp = (long) (feeMinusYUvsSignal());
            this.feeMinusYUvsSignalRaw = _tmp;
            return this.feeMinusYUvsSignalRaw;
        }
        private Integer teachwearMagnYRaw;
        public Integer teachwearMagnYRaw() {
            if (this.teachwearMagnYRaw != null)
                return this.teachwearMagnYRaw;
            int _tmp = (int) (teachwearMagnY());
            this.teachwearMagnYRaw = _tmp;
            return this.teachwearMagnYRaw;
        }
        private Long hkMinus5vPolarRaw;
        public Long hkMinus5vPolarRaw() {
            if (this.hkMinus5vPolarRaw != null)
                return this.hkMinus5vPolarRaw;
            long _tmp = (long) (hkMinus5vPolar());
            this.hkMinus5vPolarRaw = _tmp;
            return this.hkMinus5vPolarRaw;
        }
        private Integer teachwearGyroZRaw;
        public Integer teachwearGyroZRaw() {
            if (this.teachwearGyroZRaw != null)
                return this.teachwearGyroZRaw;
            int _tmp = (int) (teachwearGyroZ());
            this.teachwearGyroZRaw = _tmp;
            return this.teachwearGyroZRaw;
        }
        private Long feePlusXErs2TemperatureRaw;
        public Long feePlusXErs2TemperatureRaw() {
            if (this.feePlusXErs2TemperatureRaw != null)
                return this.feePlusXErs2TemperatureRaw;
            long _tmp = (long) (feePlusXErs2Temperature());
            this.feePlusXErs2TemperatureRaw = _tmp;
            return this.feePlusXErs2TemperatureRaw;
        }
        private Long feeMinusYErs3TemperatureRaw;
        public Long feeMinusYErs3TemperatureRaw() {
            if (this.feeMinusYErs3TemperatureRaw != null)
                return this.feeMinusYErs3TemperatureRaw;
            long _tmp = (long) (feeMinusYErs3Temperature());
            this.feeMinusYErs3TemperatureRaw = _tmp;
            return this.feeMinusYErs3TemperatureRaw;
        }
        private Long feePlusYUvsSignalRaw;
        public Long feePlusYUvsSignalRaw() {
            if (this.feePlusYUvsSignalRaw != null)
                return this.feePlusYUvsSignalRaw;
            long _tmp = (long) (feePlusYUvsSignal());
            this.feePlusYUvsSignalRaw = _tmp;
            return this.feePlusYUvsSignalRaw;
        }
        private Long hkTempAdcRaw;
        public Long hkTempAdcRaw() {
            if (this.hkTempAdcRaw != null)
                return this.hkTempAdcRaw;
            long _tmp = (long) (hkTempAdc());
            this.hkTempAdcRaw = _tmp;
            return this.hkTempAdcRaw;
        }
        private Long feePlusXErs3TemperatureRaw;
        public Long feePlusXErs3TemperatureRaw() {
            if (this.feePlusXErs3TemperatureRaw != null)
                return this.feePlusXErs3TemperatureRaw;
            long _tmp = (long) (feePlusXErs3Temperature());
            this.feePlusXErs3TemperatureRaw = _tmp;
            return this.feePlusXErs3TemperatureRaw;
        }
        private Long hkFeePlusYVrefRaw;
        public Long hkFeePlusYVrefRaw() {
            if (this.hkFeePlusYVrefRaw != null)
                return this.hkFeePlusYVrefRaw;
            long _tmp = (long) (hkFeePlusYVref());
            this.hkFeePlusYVrefRaw = _tmp;
            return this.hkFeePlusYVrefRaw;
        }
        private Long feeMinusYErs3SignalRaw;
        public Long feeMinusYErs3SignalRaw() {
            if (this.feeMinusYErs3SignalRaw != null)
                return this.feeMinusYErs3SignalRaw;
            long _tmp = (long) (feeMinusYErs3Signal());
            this.feeMinusYErs3SignalRaw = _tmp;
            return this.feeMinusYErs3SignalRaw;
        }
        private Long feeMinusXErs2SignalRaw;
        public Long feeMinusXErs2SignalRaw() {
            if (this.feeMinusXErs2SignalRaw != null)
                return this.feeMinusXErs2SignalRaw;
            long _tmp = (long) (feeMinusXErs2Signal());
            this.feeMinusXErs2SignalRaw = _tmp;
            return this.feeMinusXErs2SignalRaw;
        }
        private Integer numberOfAcquisitionCommandedRaw;
        public Integer numberOfAcquisitionCommandedRaw() {
            if (this.numberOfAcquisitionCommandedRaw != null)
                return this.numberOfAcquisitionCommandedRaw;
            int _tmp = (int) (numberOfAcquisitionCommanded());
            this.numberOfAcquisitionCommandedRaw = _tmp;
            return this.numberOfAcquisitionCommandedRaw;
        }
        private Long gainRaw;
        public Long gainRaw() {
            if (this.gainRaw != null)
                return this.gainRaw;
            long _tmp = (long) (gain());
            this.gainRaw = _tmp;
            return this.gainRaw;
        }
        private Long feeMinusYErs1SignalRaw;
        public Long feeMinusYErs1SignalRaw() {
            if (this.feeMinusYErs1SignalRaw != null)
                return this.feeMinusYErs1SignalRaw;
            long _tmp = (long) (feeMinusYErs1Signal());
            this.feeMinusYErs1SignalRaw = _tmp;
            return this.feeMinusYErs1SignalRaw;
        }
        private Integer teachwearAccZRaw;
        public Integer teachwearAccZRaw() {
            if (this.teachwearAccZRaw != null)
                return this.teachwearAccZRaw;
            int _tmp = (int) (teachwearAccZ());
            this.teachwearAccZRaw = _tmp;
            return this.teachwearAccZRaw;
        }
        private Long mainboardScienceTimeRaw;
        public Long mainboardScienceTimeRaw() {
            if (this.mainboardScienceTimeRaw != null)
                return this.mainboardScienceTimeRaw;
            long _tmp = (long) (mainboardScienceTime());
            this.mainboardScienceTimeRaw = _tmp;
            return this.mainboardScienceTimeRaw;
        }
        private Long feePlusXErs3SignalRaw;
        public Long feePlusXErs3SignalRaw() {
            if (this.feePlusXErs3SignalRaw != null)
                return this.feePlusXErs3SignalRaw;
            long _tmp = (long) (feePlusXErs3Signal());
            this.feePlusXErs3SignalRaw = _tmp;
            return this.feePlusXErs3SignalRaw;
        }
        private Integer teachwearAccXRaw;
        public Integer teachwearAccXRaw() {
            if (this.teachwearAccXRaw != null)
                return this.teachwearAccXRaw;
            int _tmp = (int) (teachwearAccX());
            this.teachwearAccXRaw = _tmp;
            return this.teachwearAccXRaw;
        }
        private Long feeMinusXUvsSignalRaw;
        public Long feeMinusXUvsSignalRaw() {
            if (this.feeMinusXUvsSignalRaw != null)
                return this.feeMinusXUvsSignalRaw;
            long _tmp = (long) (feeMinusXUvsSignal());
            this.feeMinusXUvsSignalRaw = _tmp;
            return this.feeMinusXUvsSignalRaw;
        }
        private Long feePlusYErs3TemperatureRaw;
        public Long feePlusYErs3TemperatureRaw() {
            if (this.feePlusYErs3TemperatureRaw != null)
                return this.feePlusYErs3TemperatureRaw;
            long _tmp = (long) (feePlusYErs3Temperature());
            this.feePlusYErs3TemperatureRaw = _tmp;
            return this.feePlusYErs3TemperatureRaw;
        }
        private Long feeMinusXErs1TemperatureRaw;
        public Long feeMinusXErs1TemperatureRaw() {
            if (this.feeMinusXErs1TemperatureRaw != null)
                return this.feeMinusXErs1TemperatureRaw;
            long _tmp = (long) (feeMinusXErs1Temperature());
            this.feeMinusXErs1TemperatureRaw = _tmp;
            return this.feeMinusXErs1TemperatureRaw;
        }
        private Long hkPlus5vRaw;
        public Long hkPlus5vRaw() {
            if (this.hkPlus5vRaw != null)
                return this.hkPlus5vRaw;
            long _tmp = (long) (hkPlus5v());
            this.hkPlus5vRaw = _tmp;
            return this.hkPlus5vRaw;
        }
        private Integer numberOfRealAcquisitionRaw;
        public Integer numberOfRealAcquisitionRaw() {
            if (this.numberOfRealAcquisitionRaw != null)
                return this.numberOfRealAcquisitionRaw;
            int _tmp = (int) (numberOfRealAcquisition());
            this.numberOfRealAcquisitionRaw = _tmp;
            return this.numberOfRealAcquisitionRaw;
        }
        private Long feePlusYErs2SignalRaw;
        public Long feePlusYErs2SignalRaw() {
            if (this.feePlusYErs2SignalRaw != null)
                return this.feePlusYErs2SignalRaw;
            long _tmp = (long) (feePlusYErs2Signal());
            this.feePlusYErs2SignalRaw = _tmp;
            return this.feePlusYErs2SignalRaw;
        }
        private Integer teachWearOnRaw;
        public Integer teachWearOnRaw() {
            if (this.teachWearOnRaw != null)
                return this.teachWearOnRaw;
            int _tmp = (int) (teachWearOn());
            this.teachWearOnRaw = _tmp;
            return this.teachWearOnRaw;
        }
        private Integer frequenceOfAcquisitionsRaw;
        public Integer frequenceOfAcquisitionsRaw() {
            if (this.frequenceOfAcquisitionsRaw != null)
                return this.frequenceOfAcquisitionsRaw;
            int _tmp = (int) (frequenceOfAcquisitions());
            this.frequenceOfAcquisitionsRaw = _tmp;
            return this.frequenceOfAcquisitionsRaw;
        }
        private Long feePlusYErs2TemperatureRaw;
        public Long feePlusYErs2TemperatureRaw() {
            if (this.feePlusYErs2TemperatureRaw != null)
                return this.feePlusYErs2TemperatureRaw;
            long _tmp = (long) (feePlusYErs2Temperature());
            this.feePlusYErs2TemperatureRaw = _tmp;
            return this.feePlusYErs2TemperatureRaw;
        }
        private Long nbTmSinceFirstStartRaw;
        public Long nbTmSinceFirstStartRaw() {
            if (this.nbTmSinceFirstStartRaw != null)
                return this.nbTmSinceFirstStartRaw;
            long _tmp = (long) (nbTmSinceFirstStart());
            this.nbTmSinceFirstStartRaw = _tmp;
            return this.nbTmSinceFirstStartRaw;
        }
        private Integer teachwearMagnXRaw;
        public Integer teachwearMagnXRaw() {
            if (this.teachwearMagnXRaw != null)
                return this.teachwearMagnXRaw;
            int _tmp = (int) (teachwearMagnX());
            this.teachwearMagnXRaw = _tmp;
            return this.teachwearMagnXRaw;
        }
        private Long feeMinusXErs1SignalRaw;
        public Long feeMinusXErs1SignalRaw() {
            if (this.feeMinusXErs1SignalRaw != null)
                return this.feeMinusXErs1SignalRaw;
            long _tmp = (long) (feeMinusXErs1Signal());
            this.feeMinusXErs1SignalRaw = _tmp;
            return this.feeMinusXErs1SignalRaw;
        }
        private Long feeMinusXErs3SignalRaw;
        public Long feeMinusXErs3SignalRaw() {
            if (this.feeMinusXErs3SignalRaw != null)
                return this.feeMinusXErs3SignalRaw;
            long _tmp = (long) (feeMinusXErs3Signal());
            this.feeMinusXErs3SignalRaw = _tmp;
            return this.feeMinusXErs3SignalRaw;
        }
        private Long feeMinusYErs2SignalRaw;
        public Long feeMinusYErs2SignalRaw() {
            if (this.feeMinusYErs2SignalRaw != null)
                return this.feeMinusYErs2SignalRaw;
            long _tmp = (long) (feeMinusYErs2Signal());
            this.feeMinusYErs2SignalRaw = _tmp;
            return this.feeMinusYErs2SignalRaw;
        }
        private Long feeMinusYErs2TemperatureRaw;
        public Long feeMinusYErs2TemperatureRaw() {
            if (this.feeMinusYErs2TemperatureRaw != null)
                return this.feeMinusYErs2TemperatureRaw;
            long _tmp = (long) (feeMinusYErs2Temperature());
            this.feeMinusYErs2TemperatureRaw = _tmp;
            return this.feeMinusYErs2TemperatureRaw;
        }
        private Long feeMinusXErs2TemperatureRaw;
        public Long feeMinusXErs2TemperatureRaw() {
            if (this.feeMinusXErs2TemperatureRaw != null)
                return this.feeMinusXErs2TemperatureRaw;
            long _tmp = (long) (feeMinusXErs2Temperature());
            this.feeMinusXErs2TemperatureRaw = _tmp;
            return this.feeMinusXErs2TemperatureRaw;
        }
        private Long feePlusXErs1TemperatureRaw;
        public Long feePlusXErs1TemperatureRaw() {
            if (this.feePlusXErs1TemperatureRaw != null)
                return this.feePlusXErs1TemperatureRaw;
            long _tmp = (long) (feePlusXErs1Temperature());
            this.feePlusXErs1TemperatureRaw = _tmp;
            return this.feePlusXErs1TemperatureRaw;
        }
        private Long hkFeeMinusXVrefRaw;
        public Long hkFeeMinusXVrefRaw() {
            if (this.hkFeeMinusXVrefRaw != null)
                return this.hkFeeMinusXVrefRaw;
            long _tmp = (long) (hkFeeMinusXVref());
            this.hkFeeMinusXVrefRaw = _tmp;
            return this.hkFeeMinusXVrefRaw;
        }
        private Long feePlusYErs1TemperatureRaw;
        public Long feePlusYErs1TemperatureRaw() {
            if (this.feePlusYErs1TemperatureRaw != null)
                return this.feePlusYErs1TemperatureRaw;
            long _tmp = (long) (feePlusYErs1Temperature());
            this.feePlusYErs1TemperatureRaw = _tmp;
            return this.feePlusYErs1TemperatureRaw;
        }
        private Integer teachwearGyroXRaw;
        public Integer teachwearGyroXRaw() {
            if (this.teachwearGyroXRaw != null)
                return this.teachwearGyroXRaw;
            int _tmp = (int) (teachwearGyroX());
            this.teachwearGyroXRaw = _tmp;
            return this.teachwearGyroXRaw;
        }
        private Long feePlusXUvsSignalRaw;
        public Long feePlusXUvsSignalRaw() {
            if (this.feePlusXUvsSignalRaw != null)
                return this.feePlusXUvsSignalRaw;
            long _tmp = (long) (feePlusXUvsSignal());
            this.feePlusXUvsSignalRaw = _tmp;
            return this.feePlusXUvsSignalRaw;
        }
        private Long hkFeeMinusYVrefRaw;
        public Long hkFeeMinusYVrefRaw() {
            if (this.hkFeeMinusYVrefRaw != null)
                return this.hkFeeMinusYVrefRaw;
            long _tmp = (long) (hkFeeMinusYVref());
            this.hkFeeMinusYVrefRaw = _tmp;
            return this.hkFeeMinusYVrefRaw;
        }
        private Integer teachwearStateRaw;
        public Integer teachwearStateRaw() {
            if (this.teachwearStateRaw != null)
                return this.teachwearStateRaw;
            int _tmp = (int) (teachwearState());
            this.teachwearStateRaw = _tmp;
            return this.teachwearStateRaw;
        }
        private Long feePlusXErs1SignalRaw;
        public Long feePlusXErs1SignalRaw() {
            if (this.feePlusXErs1SignalRaw != null)
                return this.feePlusXErs1SignalRaw;
            long _tmp = (long) (feePlusXErs1Signal());
            this.feePlusXErs1SignalRaw = _tmp;
            return this.feePlusXErs1SignalRaw;
        }
        private Long hkMinus5vRaw;
        public Long hkMinus5vRaw() {
            if (this.hkMinus5vRaw != null)
                return this.hkMinus5vRaw;
            long _tmp = (long) (hkMinus5v());
            this.hkMinus5vRaw = _tmp;
            return this.hkMinus5vRaw;
        }
        private Long feeMinusXErs3TemperatureRaw;
        public Long feeMinusXErs3TemperatureRaw() {
            if (this.feeMinusXErs3TemperatureRaw != null)
                return this.feeMinusXErs3TemperatureRaw;
            long _tmp = (long) (feeMinusXErs3Temperature());
            this.feeMinusXErs3TemperatureRaw = _tmp;
            return this.feeMinusXErs3TemperatureRaw;
        }
        private Integer teachwearResetReasonRaw;
        public Integer teachwearResetReasonRaw() {
            if (this.teachwearResetReasonRaw != null)
                return this.teachwearResetReasonRaw;
            int _tmp = (int) (teachwearResetReason());
            this.teachwearResetReasonRaw = _tmp;
            return this.teachwearResetReasonRaw;
        }
        private Integer teachwearDegCRaw;
        public Integer teachwearDegCRaw() {
            if (this.teachwearDegCRaw != null)
                return this.teachwearDegCRaw;
            int _tmp = (int) (teachwearDegC());
            this.teachwearDegCRaw = _tmp;
            return this.teachwearDegCRaw;
        }
        private Integer teachwearGyroYRaw;
        public Integer teachwearGyroYRaw() {
            if (this.teachwearGyroYRaw != null)
                return this.teachwearGyroYRaw;
            int _tmp = (int) (teachwearGyroY());
            this.teachwearGyroYRaw = _tmp;
            return this.teachwearGyroYRaw;
        }
        private Integer teachwearMagnZRaw;
        public Integer teachwearMagnZRaw() {
            if (this.teachwearMagnZRaw != null)
                return this.teachwearMagnZRaw;
            int _tmp = (int) (teachwearMagnZ());
            this.teachwearMagnZRaw = _tmp;
            return this.teachwearMagnZRaw;
        }
        private Long feePlusYErs3SignalRaw;
        public Long feePlusYErs3SignalRaw() {
            if (this.feePlusYErs3SignalRaw != null)
                return this.feePlusYErs3SignalRaw;
            long _tmp = (long) (feePlusYErs3Signal());
            this.feePlusYErs3SignalRaw = _tmp;
            return this.feePlusYErs3SignalRaw;
        }
        private Integer teachwearAccYRaw;
        public Integer teachwearAccYRaw() {
            if (this.teachwearAccYRaw != null)
                return this.teachwearAccYRaw;
            int _tmp = (int) (teachwearAccY());
            this.teachwearAccYRaw = _tmp;
            return this.teachwearAccYRaw;
        }
        private long mainboardScienceTime;
        private int teachWearOn;
        private int frequenceOfAcquisitions;
        private long gain;
        private int numberOfAcquisitionCommanded;
        private int numberOfRealAcquisition;
        private long hkPlus5v;
        private long hkMinus5v;
        private long hkMinus5vPolar;
        private long hkTempAdc;
        private long hkFeePlusXVref;
        private long hkFeeMinusXVref;
        private long hkFeePlusYVref;
        private long hkFeeMinusYVref;
        private long feePlusXErs1Signal;
        private long feePlusXErs1Temperature;
        private long feePlusXErs2Signal;
        private long feePlusXErs2Temperature;
        private long feePlusXErs3Signal;
        private long feePlusXErs3Temperature;
        private long feePlusXUvsSignal;
        private long feeMinusXErs1Signal;
        private long feeMinusXErs1Temperature;
        private long feeMinusXErs2Signal;
        private long feeMinusXErs2Temperature;
        private long feeMinusXErs3Signal;
        private long feeMinusXErs3Temperature;
        private long feeMinusXUvsSignal;
        private long feePlusYErs1Signal;
        private long feePlusYErs1Temperature;
        private long feePlusYErs2Signal;
        private long feePlusYErs2Temperature;
        private long feePlusYErs3Signal;
        private long feePlusYErs3Temperature;
        private long feePlusYUvsSignal;
        private long feeMinusYErs1Signal;
        private long feeMinusYErs1Temperature;
        private long feeMinusYErs2Signal;
        private long feeMinusYErs2Temperature;
        private long feeMinusYErs3Signal;
        private long feeMinusYErs3Temperature;
        private long feeMinusYUvsSignal;
        private int teachwearAccX;
        private int teachwearAccY;
        private int teachwearAccZ;
        private int teachwearDegC;
        private int teachwearGyroX;
        private int teachwearGyroY;
        private int teachwearGyroZ;
        private int teachwearMagnX;
        private int teachwearMagnY;
        private int teachwearMagnZ;
        private int teachwearState;
        private int teachwearResetReason;
        private int teachwearCrc;
        private long nbTmSinceFirstStart;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long mainboardScienceTime() { return mainboardScienceTime; }
        public int teachWearOn() { return teachWearOn; }
        public int frequenceOfAcquisitions() { return frequenceOfAcquisitions; }
        public long gain() { return gain; }
        public int numberOfAcquisitionCommanded() { return numberOfAcquisitionCommanded; }
        public int numberOfRealAcquisition() { return numberOfRealAcquisition; }
        public long hkPlus5v() { return hkPlus5v; }
        public long hkMinus5v() { return hkMinus5v; }
        public long hkMinus5vPolar() { return hkMinus5vPolar; }
        public long hkTempAdc() { return hkTempAdc; }
        public long hkFeePlusXVref() { return hkFeePlusXVref; }
        public long hkFeeMinusXVref() { return hkFeeMinusXVref; }
        public long hkFeePlusYVref() { return hkFeePlusYVref; }
        public long hkFeeMinusYVref() { return hkFeeMinusYVref; }
        public long feePlusXErs1Signal() { return feePlusXErs1Signal; }
        public long feePlusXErs1Temperature() { return feePlusXErs1Temperature; }
        public long feePlusXErs2Signal() { return feePlusXErs2Signal; }
        public long feePlusXErs2Temperature() { return feePlusXErs2Temperature; }
        public long feePlusXErs3Signal() { return feePlusXErs3Signal; }
        public long feePlusXErs3Temperature() { return feePlusXErs3Temperature; }
        public long feePlusXUvsSignal() { return feePlusXUvsSignal; }
        public long feeMinusXErs1Signal() { return feeMinusXErs1Signal; }
        public long feeMinusXErs1Temperature() { return feeMinusXErs1Temperature; }
        public long feeMinusXErs2Signal() { return feeMinusXErs2Signal; }
        public long feeMinusXErs2Temperature() { return feeMinusXErs2Temperature; }
        public long feeMinusXErs3Signal() { return feeMinusXErs3Signal; }
        public long feeMinusXErs3Temperature() { return feeMinusXErs3Temperature; }
        public long feeMinusXUvsSignal() { return feeMinusXUvsSignal; }
        public long feePlusYErs1Signal() { return feePlusYErs1Signal; }
        public long feePlusYErs1Temperature() { return feePlusYErs1Temperature; }
        public long feePlusYErs2Signal() { return feePlusYErs2Signal; }
        public long feePlusYErs2Temperature() { return feePlusYErs2Temperature; }
        public long feePlusYErs3Signal() { return feePlusYErs3Signal; }
        public long feePlusYErs3Temperature() { return feePlusYErs3Temperature; }
        public long feePlusYUvsSignal() { return feePlusYUvsSignal; }
        public long feeMinusYErs1Signal() { return feeMinusYErs1Signal; }
        public long feeMinusYErs1Temperature() { return feeMinusYErs1Temperature; }
        public long feeMinusYErs2Signal() { return feeMinusYErs2Signal; }
        public long feeMinusYErs2Temperature() { return feeMinusYErs2Temperature; }
        public long feeMinusYErs3Signal() { return feeMinusYErs3Signal; }
        public long feeMinusYErs3Temperature() { return feeMinusYErs3Temperature; }
        public long feeMinusYUvsSignal() { return feeMinusYUvsSignal; }
        public int teachwearAccX() { return teachwearAccX; }
        public int teachwearAccY() { return teachwearAccY; }
        public int teachwearAccZ() { return teachwearAccZ; }
        public int teachwearDegC() { return teachwearDegC; }
        public int teachwearGyroX() { return teachwearGyroX; }
        public int teachwearGyroY() { return teachwearGyroY; }
        public int teachwearGyroZ() { return teachwearGyroZ; }
        public int teachwearMagnX() { return teachwearMagnX; }
        public int teachwearMagnY() { return teachwearMagnY; }
        public int teachwearMagnZ() { return teachwearMagnZ; }
        public int teachwearState() { return teachwearState; }
        public int teachwearResetReason() { return teachwearResetReason; }
        public int teachwearCrc() { return teachwearCrc; }
        public long nbTmSinceFirstStart() { return nbTmSinceFirstStart; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class AmsatAscii extends KaitaiStruct {
        public static AmsatAscii fromFile(String fileName) throws IOException {
            return new AmsatAscii(new ByteBufferKaitaiStream(fileName));
        }

        public AmsatAscii(KaitaiStream _io) {
            this(_io, null, null);
        }

        public AmsatAscii(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public AmsatAscii(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.message = new String(this._io.readBytesFull(), Charset.forName("UTF-8"));
        }
        private String messageStr;
        public String messageStr() {
            if (this.messageStr != null)
                return this.messageStr;
            this.messageStr = message();
            return this.messageStr;
        }
        private String message;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public String message() { return message; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class TrxvurxHk extends KaitaiStruct {
        public static TrxvurxHk fromFile(String fileName) throws IOException {
            return new TrxvurxHk(new ByteBufferKaitaiStream(fileName));
        }

        public TrxvurxHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public TrxvurxHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public TrxvurxHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort = this._io.readBitsInt(12);
            this.trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort = this._io.readBitsInt(12);
            this.trxvurxSupplyVoltage = this._io.readBitsInt(12);
            this.trxvurxTotalSupplyCurrent = this._io.readBitsInt(12);
            this.trxvurxTransmitterCurrent = this._io.readBitsInt(12);
            this.trxvurxReceiverCurrent = this._io.readBitsInt(12);
            this.trxvurxPowerAmplifierCurrent = this._io.readBitsInt(12);
            this.trxvurxPowerAmplifierTemperature = this._io.readBitsInt(12);
            this.trxvurxLocalOscillatorTemperature = this._io.readBitsInt(12);
            this.trxvurxZeroPadding = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.trxvuRxUptime = this._io.readU4be();
        }
        private Double trxvurxInstantaneousReceivedSignalStrengthDbm;
        public Double trxvurxInstantaneousReceivedSignalStrengthDbm() {
            if (this.trxvurxInstantaneousReceivedSignalStrengthDbm != null)
                return this.trxvurxInstantaneousReceivedSignalStrengthDbm;
            double _tmp = (double) (((trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort() * 0.03) - 152));
            this.trxvurxInstantaneousReceivedSignalStrengthDbm = _tmp;
            return this.trxvurxInstantaneousReceivedSignalStrengthDbm;
        }
        private Double trxvurxInstantaneousReceivedSignalDopplerHz;
        public Double trxvurxInstantaneousReceivedSignalDopplerHz() {
            if (this.trxvurxInstantaneousReceivedSignalDopplerHz != null)
                return this.trxvurxInstantaneousReceivedSignalDopplerHz;
            double _tmp = (double) (((trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort() * 13.552) - 22300));
            this.trxvurxInstantaneousReceivedSignalDopplerHz = _tmp;
            return this.trxvurxInstantaneousReceivedSignalDopplerHz;
        }
        private Double trxvurxSupplyVoltageV;
        public Double trxvurxSupplyVoltageV() {
            if (this.trxvurxSupplyVoltageV != null)
                return this.trxvurxSupplyVoltageV;
            double _tmp = (double) ((trxvurxSupplyVoltage() * 0.00488));
            this.trxvurxSupplyVoltageV = _tmp;
            return this.trxvurxSupplyVoltageV;
        }
        private Double trxvurxLocalOscillatorTemperatureC;
        public Double trxvurxLocalOscillatorTemperatureC() {
            if (this.trxvurxLocalOscillatorTemperatureC != null)
                return this.trxvurxLocalOscillatorTemperatureC;
            double _tmp = (double) (((trxvurxLocalOscillatorTemperature() * -0.07669) + 195.6037));
            this.trxvurxLocalOscillatorTemperatureC = _tmp;
            return this.trxvurxLocalOscillatorTemperatureC;
        }
        private Double trxvurxTransmitterCurrentMa;
        public Double trxvurxTransmitterCurrentMa() {
            if (this.trxvurxTransmitterCurrentMa != null)
                return this.trxvurxTransmitterCurrentMa;
            double _tmp = (double) ((trxvurxTransmitterCurrent() * 0.16643964));
            this.trxvurxTransmitterCurrentMa = _tmp;
            return this.trxvurxTransmitterCurrentMa;
        }
        private Long trxvurxZeroPaddingRaw;
        public Long trxvurxZeroPaddingRaw() {
            if (this.trxvurxZeroPaddingRaw != null)
                return this.trxvurxZeroPaddingRaw;
            long _tmp = (long) (trxvurxZeroPadding());
            this.trxvurxZeroPaddingRaw = _tmp;
            return this.trxvurxZeroPaddingRaw;
        }
        private Double trxvurxPowerAmplifierCurrentMa;
        public Double trxvurxPowerAmplifierCurrentMa() {
            if (this.trxvurxPowerAmplifierCurrentMa != null)
                return this.trxvurxPowerAmplifierCurrentMa;
            double _tmp = (double) (((1000.0 * trxvurxPowerAmplifierCurrent()) * 0.16643964));
            this.trxvurxPowerAmplifierCurrentMa = _tmp;
            return this.trxvurxPowerAmplifierCurrentMa;
        }
        private Double trxvurxTotalSupplyCurrentMa;
        public Double trxvurxTotalSupplyCurrentMa() {
            if (this.trxvurxTotalSupplyCurrentMa != null)
                return this.trxvurxTotalSupplyCurrentMa;
            double _tmp = (double) ((trxvurxTotalSupplyCurrent() * 0.16643964));
            this.trxvurxTotalSupplyCurrentMa = _tmp;
            return this.trxvurxTotalSupplyCurrentMa;
        }
        private Double trxvurxPowerAmplifierTemperatureC;
        public Double trxvurxPowerAmplifierTemperatureC() {
            if (this.trxvurxPowerAmplifierTemperatureC != null)
                return this.trxvurxPowerAmplifierTemperatureC;
            double _tmp = (double) (((trxvurxPowerAmplifierTemperature() * -0.07669) + 195.6037));
            this.trxvurxPowerAmplifierTemperatureC = _tmp;
            return this.trxvurxPowerAmplifierTemperatureC;
        }
        private Long trxvuRxUptimeRaw;
        public Long trxvuRxUptimeRaw() {
            if (this.trxvuRxUptimeRaw != null)
                return this.trxvuRxUptimeRaw;
            long _tmp = (long) (trxvuRxUptime());
            this.trxvuRxUptimeRaw = _tmp;
            return this.trxvuRxUptimeRaw;
        }
        private Double trxvurxReceiverCurrentMa;
        public Double trxvurxReceiverCurrentMa() {
            if (this.trxvurxReceiverCurrentMa != null)
                return this.trxvurxReceiverCurrentMa;
            double _tmp = (double) ((trxvurxReceiverCurrent() * 0.16643964));
            this.trxvurxReceiverCurrentMa = _tmp;
            return this.trxvurxReceiverCurrentMa;
        }
        private long trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort;
        private long trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort;
        private long trxvurxSupplyVoltage;
        private long trxvurxTotalSupplyCurrent;
        private long trxvurxTransmitterCurrent;
        private long trxvurxReceiverCurrent;
        private long trxvurxPowerAmplifierCurrent;
        private long trxvurxPowerAmplifierTemperature;
        private long trxvurxLocalOscillatorTemperature;
        private long trxvurxZeroPadding;
        private long trxvuRxUptime;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort() { return trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort; }
        public long trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort() { return trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort; }
        public long trxvurxSupplyVoltage() { return trxvurxSupplyVoltage; }
        public long trxvurxTotalSupplyCurrent() { return trxvurxTotalSupplyCurrent; }
        public long trxvurxTransmitterCurrent() { return trxvurxTransmitterCurrent; }
        public long trxvurxReceiverCurrent() { return trxvurxReceiverCurrent; }
        public long trxvurxPowerAmplifierCurrent() { return trxvurxPowerAmplifierCurrent; }
        public long trxvurxPowerAmplifierTemperature() { return trxvurxPowerAmplifierTemperature; }
        public long trxvurxLocalOscillatorTemperature() { return trxvurxLocalOscillatorTemperature; }
        public long trxvurxZeroPadding() { return trxvurxZeroPadding; }
        public long trxvuRxUptime() { return trxvuRxUptime; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class MainboardHk extends KaitaiStruct {
        public static MainboardHk fromFile(String fileName) throws IOException {
            return new MainboardHk(new ByteBufferKaitaiStream(fileName));
        }

        public MainboardHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public MainboardHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public MainboardHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.mainboardHkTime = this._io.readU4be();
            this.hkPlus5V = this._io.readU2be();
            this.hkMinus5V = this._io.readU2be();
            this.hkMinusPolar = this._io.readU2be();
            this.hkTempADC = this._io.readU2be();
            this.hkFeePlusXVref = this._io.readU2be();
            this.hkFeeMinusXVref = this._io.readU2be();
            this.hkFeePlusYVref = this._io.readU2be();
            this.hkFeeMinusYVref = this._io.readU2be();
        }
        private Integer hkFeePlusXVrefRaw;
        public Integer hkFeePlusXVrefRaw() {
            if (this.hkFeePlusXVrefRaw != null)
                return this.hkFeePlusXVrefRaw;
            int _tmp = (int) (hkFeePlusXVref());
            this.hkFeePlusXVrefRaw = _tmp;
            return this.hkFeePlusXVrefRaw;
        }
        private Integer hkFeePlusYVrefRaw;
        public Integer hkFeePlusYVrefRaw() {
            if (this.hkFeePlusYVrefRaw != null)
                return this.hkFeePlusYVrefRaw;
            int _tmp = (int) (hkFeePlusYVref());
            this.hkFeePlusYVrefRaw = _tmp;
            return this.hkFeePlusYVrefRaw;
        }
        private Integer hkPlus5VRaw;
        public Integer hkPlus5VRaw() {
            if (this.hkPlus5VRaw != null)
                return this.hkPlus5VRaw;
            int _tmp = (int) (hkPlus5V());
            this.hkPlus5VRaw = _tmp;
            return this.hkPlus5VRaw;
        }
        private Integer hkTempADCRaw;
        public Integer hkTempADCRaw() {
            if (this.hkTempADCRaw != null)
                return this.hkTempADCRaw;
            int _tmp = (int) (hkTempADC());
            this.hkTempADCRaw = _tmp;
            return this.hkTempADCRaw;
        }
        private Long mainboardHKTimeRaw;
        public Long mainboardHKTimeRaw() {
            if (this.mainboardHKTimeRaw != null)
                return this.mainboardHKTimeRaw;
            long _tmp = (long) (mainboardHkTime());
            this.mainboardHKTimeRaw = _tmp;
            return this.mainboardHKTimeRaw;
        }
        private Integer hkMinusPolarRaw;
        public Integer hkMinusPolarRaw() {
            if (this.hkMinusPolarRaw != null)
                return this.hkMinusPolarRaw;
            int _tmp = (int) (hkMinusPolar());
            this.hkMinusPolarRaw = _tmp;
            return this.hkMinusPolarRaw;
        }
        private Integer hkMinus5VRaw;
        public Integer hkMinus5VRaw() {
            if (this.hkMinus5VRaw != null)
                return this.hkMinus5VRaw;
            int _tmp = (int) (hkMinus5V());
            this.hkMinus5VRaw = _tmp;
            return this.hkMinus5VRaw;
        }
        private Integer hkFeeMinusXVrefRaw;
        public Integer hkFeeMinusXVrefRaw() {
            if (this.hkFeeMinusXVrefRaw != null)
                return this.hkFeeMinusXVrefRaw;
            int _tmp = (int) (hkFeeMinusXVref());
            this.hkFeeMinusXVrefRaw = _tmp;
            return this.hkFeeMinusXVrefRaw;
        }
        private Integer hkFeeMinusYVrefRaw;
        public Integer hkFeeMinusYVrefRaw() {
            if (this.hkFeeMinusYVrefRaw != null)
                return this.hkFeeMinusYVrefRaw;
            int _tmp = (int) (hkFeeMinusYVref());
            this.hkFeeMinusYVrefRaw = _tmp;
            return this.hkFeeMinusYVrefRaw;
        }
        private long mainboardHkTime;
        private int hkPlus5V;
        private int hkMinus5V;
        private int hkMinusPolar;
        private int hkTempADC;
        private int hkFeePlusXVref;
        private int hkFeeMinusXVref;
        private int hkFeePlusYVref;
        private int hkFeeMinusYVref;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long mainboardHkTime() { return mainboardHkTime; }
        public int hkPlus5V() { return hkPlus5V; }
        public int hkMinus5V() { return hkMinus5V; }
        public int hkMinusPolar() { return hkMinusPolar; }
        public int hkTempADC() { return hkTempADC; }
        public int hkFeePlusXVref() { return hkFeePlusXVref; }
        public int hkFeeMinusXVref() { return hkFeeMinusXVref; }
        public int hkFeePlusYVref() { return hkFeePlusYVref; }
        public int hkFeeMinusYVref() { return hkFeeMinusYVref; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class IFrame extends KaitaiStruct {
        public static IFrame fromFile(String fileName) throws IOException {
            return new IFrame(new ByteBufferKaitaiStream(fileName));
        }

        public IFrame(KaitaiStream _io) {
            this(_io, null, null);
        }

        public IFrame(KaitaiStream _io, Uvsqsat.Ax25Frame _parent) {
            this(_io, _parent, null);
        }

        public IFrame(KaitaiStream _io, Uvsqsat.Ax25Frame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.pid = this._io.readU1();
            this.ax25Info = this._io.readBytesFull();
        }
        private int pid;
        private byte[] ax25Info;
        private Uvsqsat _root;
        private Uvsqsat.Ax25Frame _parent;
        public int pid() { return pid; }
        public byte[] ax25Info() { return ax25Info; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.Ax25Frame _parent() { return _parent; }
    }
    public static class ObcStatus extends KaitaiStruct {
        public static ObcStatus fromFile(String fileName) throws IOException {
            return new ObcStatus(new ByteBufferKaitaiStream(fileName));
        }

        public ObcStatus(KaitaiStream _io) {
            this(_io, null, null);
        }

        public ObcStatus(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public ObcStatus(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.dummy = this._io.readU1();
            this.spiCommandStatus = this._io.readU1();
            this.supervisorIndexOfSubsystem = this._io.readU1();
            this.supervisorMajorVersion = this._io.readU1();
            this.supervisorMinorVersion = this._io.readU1();
            this.supervisorPatchVersion = this._io.readU1();
            this.supervisorGitHeadVersion = this._io.readU4be();
            this.supervisorSerialNumber = this._io.readU2be();
            this.compilationInformation = this._io.readBytes(19);
            this.clockSpeed = this._io.readU1();
            this.codeType = this._io.readU1();
            this.crc8 = this._io.readU1();
            this.swMmode = this._io.readU1();
            this.lastResetReason = this._io.readU1();
            this.reserved = this._io.readU1();
            this.nbReset = this._io.readU1();
            this.reserved2 = this._io.readU1();
            this.deployAntennasSystem = this._io.readU1();
            this.nbTmSinceFirstStart = this._io.readU4be();
            this.nbTcSinceFirstStart = this._io.readU4be();
            this.nbBadTcSinceFirstStart = this._io.readU4be();
            this.nbTmInSdcard = this._io.readU4be();
            this.sdcardStatus = this._io.readU1();
            this.sdcardLastError = this._io.readU4be();
            this.oldTimeTMInSdcard = this._io.readBitsInt(56);
            this.newTimeTMInSdcard = this._io.readBitsInt(56);
        }
        private Long newTimeTMInSdcardRaw;
        public Long newTimeTMInSdcardRaw() {
            if (this.newTimeTMInSdcardRaw != null)
                return this.newTimeTMInSdcardRaw;
            long _tmp = (long) (newTimeTMInSdcard());
            this.newTimeTMInSdcardRaw = _tmp;
            return this.newTimeTMInSdcardRaw;
        }
        private Integer deployAntennasSystemRaw;
        public Integer deployAntennasSystemRaw() {
            if (this.deployAntennasSystemRaw != null)
                return this.deployAntennasSystemRaw;
            int _tmp = (int) (deployAntennasSystem());
            this.deployAntennasSystemRaw = _tmp;
            return this.deployAntennasSystemRaw;
        }
        private Integer clockSpeedRaw;
        public Integer clockSpeedRaw() {
            if (this.clockSpeedRaw != null)
                return this.clockSpeedRaw;
            int _tmp = (int) (clockSpeed());
            this.clockSpeedRaw = _tmp;
            return this.clockSpeedRaw;
        }
        private Integer lastResetReasonRaw;
        public Integer lastResetReasonRaw() {
            if (this.lastResetReasonRaw != null)
                return this.lastResetReasonRaw;
            int _tmp = (int) (lastResetReason());
            this.lastResetReasonRaw = _tmp;
            return this.lastResetReasonRaw;
        }
        private Integer supervisorIndexOfSubsystemRaw;
        public Integer supervisorIndexOfSubsystemRaw() {
            if (this.supervisorIndexOfSubsystemRaw != null)
                return this.supervisorIndexOfSubsystemRaw;
            int _tmp = (int) (supervisorIndexOfSubsystem());
            this.supervisorIndexOfSubsystemRaw = _tmp;
            return this.supervisorIndexOfSubsystemRaw;
        }
        private Integer crc8Raw;
        public Integer crc8Raw() {
            if (this.crc8Raw != null)
                return this.crc8Raw;
            int _tmp = (int) (crc8());
            this.crc8Raw = _tmp;
            return this.crc8Raw;
        }
        private Integer nbResetRaw;
        public Integer nbResetRaw() {
            if (this.nbResetRaw != null)
                return this.nbResetRaw;
            int _tmp = (int) (nbReset());
            this.nbResetRaw = _tmp;
            return this.nbResetRaw;
        }
        private Long supervisorGitHeadVersionRaw;
        public Long supervisorGitHeadVersionRaw() {
            if (this.supervisorGitHeadVersionRaw != null)
                return this.supervisorGitHeadVersionRaw;
            long _tmp = (long) (supervisorGitHeadVersion());
            this.supervisorGitHeadVersionRaw = _tmp;
            return this.supervisorGitHeadVersionRaw;
        }
        private Integer supervisorMajorVersionRaw;
        public Integer supervisorMajorVersionRaw() {
            if (this.supervisorMajorVersionRaw != null)
                return this.supervisorMajorVersionRaw;
            int _tmp = (int) (supervisorMajorVersion());
            this.supervisorMajorVersionRaw = _tmp;
            return this.supervisorMajorVersionRaw;
        }
        private byte[] compilationInformationByte;
        public byte[] compilationInformationByte() {
            if (this.compilationInformationByte != null)
                return this.compilationInformationByte;
            this.compilationInformationByte = compilationInformation();
            return this.compilationInformationByte;
        }
        private Long nbTmSinceFirstStartRaw;
        public Long nbTmSinceFirstStartRaw() {
            if (this.nbTmSinceFirstStartRaw != null)
                return this.nbTmSinceFirstStartRaw;
            long _tmp = (long) (nbTmSinceFirstStart());
            this.nbTmSinceFirstStartRaw = _tmp;
            return this.nbTmSinceFirstStartRaw;
        }
        private Integer supervisorMinorVersionRaw;
        public Integer supervisorMinorVersionRaw() {
            if (this.supervisorMinorVersionRaw != null)
                return this.supervisorMinorVersionRaw;
            int _tmp = (int) (supervisorMinorVersion());
            this.supervisorMinorVersionRaw = _tmp;
            return this.supervisorMinorVersionRaw;
        }
        private Integer sdcardStatusRaw;
        public Integer sdcardStatusRaw() {
            if (this.sdcardStatusRaw != null)
                return this.sdcardStatusRaw;
            int _tmp = (int) (sdcardStatus());
            this.sdcardStatusRaw = _tmp;
            return this.sdcardStatusRaw;
        }
        private Integer supervisorPatchVersionRaw;
        public Integer supervisorPatchVersionRaw() {
            if (this.supervisorPatchVersionRaw != null)
                return this.supervisorPatchVersionRaw;
            int _tmp = (int) (supervisorPatchVersion());
            this.supervisorPatchVersionRaw = _tmp;
            return this.supervisorPatchVersionRaw;
        }
        private Integer reservedRaw;
        public Integer reservedRaw() {
            if (this.reservedRaw != null)
                return this.reservedRaw;
            int _tmp = (int) (reserved());
            this.reservedRaw = _tmp;
            return this.reservedRaw;
        }
        private Integer supervisorSerialNumberRaw;
        public Integer supervisorSerialNumberRaw() {
            if (this.supervisorSerialNumberRaw != null)
                return this.supervisorSerialNumberRaw;
            int _tmp = (int) (supervisorSerialNumber());
            this.supervisorSerialNumberRaw = _tmp;
            return this.supervisorSerialNumberRaw;
        }
        private Long nbTmInSdcardRaw;
        public Long nbTmInSdcardRaw() {
            if (this.nbTmInSdcardRaw != null)
                return this.nbTmInSdcardRaw;
            long _tmp = (long) (nbTmInSdcard());
            this.nbTmInSdcardRaw = _tmp;
            return this.nbTmInSdcardRaw;
        }
        private Integer reserved2Raw;
        public Integer reserved2Raw() {
            if (this.reserved2Raw != null)
                return this.reserved2Raw;
            int _tmp = (int) (reserved2());
            this.reserved2Raw = _tmp;
            return this.reserved2Raw;
        }
        private Integer swMmodeRaw;
        public Integer swMmodeRaw() {
            if (this.swMmodeRaw != null)
                return this.swMmodeRaw;
            int _tmp = (int) (swMmode());
            this.swMmodeRaw = _tmp;
            return this.swMmodeRaw;
        }
        private Integer codeTypeRaw;
        public Integer codeTypeRaw() {
            if (this.codeTypeRaw != null)
                return this.codeTypeRaw;
            int _tmp = (int) (codeType());
            this.codeTypeRaw = _tmp;
            return this.codeTypeRaw;
        }
        private Long oldTimeTMInSdcardRaw;
        public Long oldTimeTMInSdcardRaw() {
            if (this.oldTimeTMInSdcardRaw != null)
                return this.oldTimeTMInSdcardRaw;
            long _tmp = (long) (oldTimeTMInSdcard());
            this.oldTimeTMInSdcardRaw = _tmp;
            return this.oldTimeTMInSdcardRaw;
        }
        private Integer dummydummy;
        public Integer dummydummy() {
            if (this.dummydummy != null)
                return this.dummydummy;
            int _tmp = (int) (dummy());
            this.dummydummy = _tmp;
            return this.dummydummy;
        }
        private Long nbTcSinceFirstStartRaw;
        public Long nbTcSinceFirstStartRaw() {
            if (this.nbTcSinceFirstStartRaw != null)
                return this.nbTcSinceFirstStartRaw;
            long _tmp = (long) (nbTcSinceFirstStart());
            this.nbTcSinceFirstStartRaw = _tmp;
            return this.nbTcSinceFirstStartRaw;
        }
        private Long sdcardLastErrorRaw;
        public Long sdcardLastErrorRaw() {
            if (this.sdcardLastErrorRaw != null)
                return this.sdcardLastErrorRaw;
            long _tmp = (long) (sdcardLastError());
            this.sdcardLastErrorRaw = _tmp;
            return this.sdcardLastErrorRaw;
        }
        private Long nbBadTcSinceFirstStartRaw;
        public Long nbBadTcSinceFirstStartRaw() {
            if (this.nbBadTcSinceFirstStartRaw != null)
                return this.nbBadTcSinceFirstStartRaw;
            long _tmp = (long) (nbBadTcSinceFirstStart());
            this.nbBadTcSinceFirstStartRaw = _tmp;
            return this.nbBadTcSinceFirstStartRaw;
        }
        private Integer spiCommandStatusRaw;
        public Integer spiCommandStatusRaw() {
            if (this.spiCommandStatusRaw != null)
                return this.spiCommandStatusRaw;
            int _tmp = (int) (spiCommandStatus());
            this.spiCommandStatusRaw = _tmp;
            return this.spiCommandStatusRaw;
        }
        private int dummy;
        private int spiCommandStatus;
        private int supervisorIndexOfSubsystem;
        private int supervisorMajorVersion;
        private int supervisorMinorVersion;
        private int supervisorPatchVersion;
        private long supervisorGitHeadVersion;
        private int supervisorSerialNumber;
        private byte[] compilationInformation;
        private int clockSpeed;
        private int codeType;
        private int crc8;
        private int swMmode;
        private int lastResetReason;
        private int reserved;
        private int nbReset;
        private int reserved2;
        private int deployAntennasSystem;
        private long nbTmSinceFirstStart;
        private long nbTcSinceFirstStart;
        private long nbBadTcSinceFirstStart;
        private long nbTmInSdcard;
        private int sdcardStatus;
        private long sdcardLastError;
        private long oldTimeTMInSdcard;
        private long newTimeTMInSdcard;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int dummy() { return dummy; }
        public int spiCommandStatus() { return spiCommandStatus; }
        public int supervisorIndexOfSubsystem() { return supervisorIndexOfSubsystem; }
        public int supervisorMajorVersion() { return supervisorMajorVersion; }
        public int supervisorMinorVersion() { return supervisorMinorVersion; }
        public int supervisorPatchVersion() { return supervisorPatchVersion; }
        public long supervisorGitHeadVersion() { return supervisorGitHeadVersion; }
        public int supervisorSerialNumber() { return supervisorSerialNumber; }
        public byte[] compilationInformation() { return compilationInformation; }
        public int clockSpeed() { return clockSpeed; }
        public int codeType() { return codeType; }
        public int crc8() { return crc8; }
        public int swMmode() { return swMmode; }
        public int lastResetReason() { return lastResetReason; }
        public int reserved() { return reserved; }
        public int nbReset() { return nbReset; }
        public int reserved2() { return reserved2; }
        public int deployAntennasSystem() { return deployAntennasSystem; }
        public long nbTmSinceFirstStart() { return nbTmSinceFirstStart; }
        public long nbTcSinceFirstStart() { return nbTcSinceFirstStart; }
        public long nbBadTcSinceFirstStart() { return nbBadTcSinceFirstStart; }
        public long nbTmInSdcard() { return nbTmInSdcard; }
        public int sdcardStatus() { return sdcardStatus; }
        public long sdcardLastError() { return sdcardLastError; }
        public long oldTimeTMInSdcard() { return oldTimeTMInSdcard; }
        public long newTimeTMInSdcard() { return newTimeTMInSdcard; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class SsidMask extends KaitaiStruct {
        public static SsidMask fromFile(String fileName) throws IOException {
            return new SsidMask(new ByteBufferKaitaiStream(fileName));
        }

        public SsidMask(KaitaiStream _io) {
            this(_io, null, null);
        }

        public SsidMask(KaitaiStream _io, Uvsqsat.Ax25Header _parent) {
            this(_io, _parent, null);
        }

        public SsidMask(KaitaiStream _io, Uvsqsat.Ax25Header _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.ssidMask = this._io.readU1();
        }
        private Integer ssid;
        public Integer ssid() {
            if (this.ssid != null)
                return this.ssid;
            int _tmp = (int) (((ssidMask() & 15) >> 1));
            this.ssid = _tmp;
            return this.ssid;
        }
        private int ssidMask;
        private Uvsqsat _root;
        private Uvsqsat.Ax25Header _parent;
        public int ssidMask() { return ssidMask; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.Ax25Header _parent() { return _parent; }
    }
    public static class Beacon extends KaitaiStruct {
        public static Beacon fromFile(String fileName) throws IOException {
            return new Beacon(new ByteBufferKaitaiStream(fileName));
        }

        public Beacon(KaitaiStream _io) {
            this(_io, null, null);
        }

        public Beacon(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public Beacon(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.swMode = this._io.readU1();
            this.lastResetReason = this._io.readU1();
            this.resetOrder = this._io.readU1();
            this.nbReset = this._io.readU1();
            this.formatSdcardOrder = this._io.readU1();
            this.deployAntennasSystem = this._io.readU1();
            this.nbTmSinceFirstStart = this._io.readU4be();
            this.nbTcSinceFirstStart = this._io.readU4be();
            this.nbTcPingSinceFirstStart = this._io.readU4be();
            this.nbBadTcSinceFirstStart = this._io.readU4be();
            this.nbTmInSdcard = this._io.readU4be();
            this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPort = this._io.readBitsInt(12);
            this.trxvutxInstantaneousRfForwardPowerFromTransmitterPort = this._io.readBitsInt(12);
            this.trxvutxSupplyVoltage = this._io.readBitsInt(12);
            this.trxvutxTotalSupplyCurrent = this._io.readBitsInt(12);
            this.trxvutxTransmitterCurrent = this._io.readBitsInt(12);
            this.trxvutxReceiverCurrent = this._io.readBitsInt(12);
            this.trxvutxPowerAmplifierCurrent = this._io.readBitsInt(12);
            this.trxvutxPowerAmplifierTemperature = this._io.readBitsInt(12);
            this.trxvutxLocalOscillatorTemperature = this._io.readBitsInt(12);
            this.trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort = this._io.readBitsInt(12);
            this.trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort = this._io.readBitsInt(12);
            this.trxvurxSupplyVoltage = this._io.readBitsInt(12);
            this.trxvurxTotalSupplyCurrent = this._io.readBitsInt(12);
            this.trxvurxTransmitterCurrent = this._io.readBitsInt(12);
            this.trxvurxReceiverCurrent = this._io.readBitsInt(12);
            this.trxvurxPowerAmplifierCurrent = this._io.readBitsInt(12);
            this.trxvurxPowerAmplifierTemperature = this._io.readBitsInt(12);
            this.trxvurxLocalOscillatorTemperature = this._io.readBitsInt(12);
            this._io.alignToByte();
            this.imtqSystemStateMode = this._io.readU1();
            this.measureCoilXCurrent = this._io.readU2be();
            this.measureCoilYCurrent = this._io.readU2be();
            this.measureCoilZCurrent = this._io.readU2be();
            this.measureCoilXTemperature = this._io.readU2be();
            this.measureCoilYTemperature = this._io.readU2be();
            this.measureCoilZTemperature = this._io.readU2be();
            this.mcuTemperature = this._io.readU2be();
            this.sideAAntsTemperature = this._io.readU2be();
            this.sideAAntsDeploymentStatus = this._io.readU2be();
            this.voltBrdSupRaw = this._io.readU2be();
            this.tempRaw = this._io.readU2be();
            this.vDistInputRaw = this._io.readU2be();
            this.iDistInputRaw = this._io.readU2be();
            this.pDistInputRaw = this._io.readU2be();
            this.vBattInputRaw = this._io.readU2be();
            this.iBattInputRaw = this._io.readU2be();
            this.pBattInputRaw = this._io.readU2be();
            this.statObcOn = this._io.readU2be();
            this.statObcOcf = this._io.readU2be();
            this.batStat = this._io.readU2be();
            this.batTemp2Raw = this._io.readU2be();
            this.voltVd0 = this._io.readU2be();
            this.voltVd1 = this._io.readU2be();
            this.voltVd2 = this._io.readU2be();
            this.vObc00 = this._io.readU2be();
            this.iObc00 = this._io.readU2be();
            this.pObc00 = this._io.readU2be();
            this.vObc01 = this._io.readU2be();
            this.iObc01 = this._io.readU2be();
            this.pObc01 = this._io.readU2be();
            this.vObc02 = this._io.readU2be();
            this.iObc02 = this._io.readU2be();
            this.pObc02 = this._io.readU2be();
            this.vObc03 = this._io.readU2be();
            this.iObc03 = this._io.readU2be();
            this.pObc03 = this._io.readU2be();
            this.vObc05 = this._io.readU2be();
            this.iObc05 = this._io.readU2be();
            this.pObc05 = this._io.readU2be();
            this.vObc06 = this._io.readU2be();
            this.iObc06 = this._io.readU2be();
            this.pObc06 = this._io.readU2be();
            this.statusStid = this._io.readU1();
            this.statusIvid = this._io.readU1();
            this.statusRc = this._io.readU1();
            this.statusBid = this._io.readU1();
            this.statusCmderr = this._io.readBitsInt(4);
            this.statusStat = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.mode = this._io.readU1();
            this.conf = this._io.readU1();
            this.resetCause = this._io.readU1();
            this.uptime = this._io.readU4be();
            this.error = this._io.readU2be();
            this.rcCntPwron = this._io.readU2be();
            this.rcCntWdg = this._io.readU2be();
            this.rcCntCmd = this._io.readU2be();
            this.rcCntMcu = this._io.readU2be();
            this.rcCntEmlopo = this._io.readU2be();
            this.prevcmdElapsed = this._io.readU2be();
            this.photodiode1 = this._io.readU2be();
            this.photodiode2 = this._io.readU2be();
            this.photodiode3 = this._io.readU2be();
            this.photodiode4 = this._io.readU2be();
            this.photodiode5 = this._io.readU2be();
            this.photodiode6 = this._io.readU2be();
            this.panelTemperature1 = this._io.readS4be();
            this.panelTemperature2 = this._io.readS4be();
            this.panelTemperature3 = this._io.readS4be();
            this.panelTemperature4 = this._io.readS4be();
            this.panelTemperature5 = this._io.readS4be();
            this.panelTemperature6 = this._io.readS4be();
        }
        private Double measureCoilYTemperatureC;
        public Double measureCoilYTemperatureC() {
            if (this.measureCoilYTemperatureC != null)
                return this.measureCoilYTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilYTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilYTemperatureC = _tmp;
            return this.measureCoilYTemperatureC;
        }
        private Integer rcCntPwronRaw;
        public Integer rcCntPwronRaw() {
            if (this.rcCntPwronRaw != null)
                return this.rcCntPwronRaw;
            int _tmp = (int) (rcCntPwron());
            this.rcCntPwronRaw = _tmp;
            return this.rcCntPwronRaw;
        }
        private Integer deployAntennasSystemRaw;

        /**
         * : value 
         * Nominal = 0 
         * No deploy = 0x11 
         * Deployment Debug = 0xDB
         */
        public Integer deployAntennasSystemRaw() {
            if (this.deployAntennasSystemRaw != null)
                return this.deployAntennasSystemRaw;
            int _tmp = (int) (deployAntennasSystem());
            this.deployAntennasSystemRaw = _tmp;
            return this.deployAntennasSystemRaw;
        }
        private Double vDistInputRawV;
        public Double vDistInputRawV() {
            if (this.vDistInputRawV != null)
                return this.vDistInputRawV;
            double _tmp = (double) ((((vDistInputRaw() * 125.0) / 128.0) / 1000.0));
            this.vDistInputRawV = _tmp;
            return this.vDistInputRawV;
        }
        private Double iObc05Ma;
        public Double iObc05Ma() {
            if (this.iObc05Ma != null)
                return this.iObc05Ma;
            double _tmp = (double) (((iObc05() * 3125.0) / 20480.0));
            this.iObc05Ma = _tmp;
            return this.iObc05Ma;
        }
        private Double trxvutxTotalSupplyCurrentMa;
        public Double trxvutxTotalSupplyCurrentMa() {
            if (this.trxvutxTotalSupplyCurrentMa != null)
                return this.trxvutxTotalSupplyCurrentMa;
            double _tmp = (double) ((0.16643964 * trxvutxTotalSupplyCurrent()));
            this.trxvutxTotalSupplyCurrentMa = _tmp;
            return this.trxvutxTotalSupplyCurrentMa;
        }
        private Integer lastResetReasonRaw;

        /**
         * : last reset value
         * First start = 0 
         * TC Init received = 0x80 
         * No TC since 4 days = 0x81 
         * Unknown reason = 0x81
         */
        public Integer lastResetReasonRaw() {
            if (this.lastResetReasonRaw != null)
                return this.lastResetReasonRaw;
            int _tmp = (int) (lastResetReason());
            this.lastResetReasonRaw = _tmp;
            return this.lastResetReasonRaw;
        }
        private Double trxvutxPowerAmplifierCurrentMa;
        public Double trxvutxPowerAmplifierCurrentMa() {
            if (this.trxvutxPowerAmplifierCurrentMa != null)
                return this.trxvutxPowerAmplifierCurrentMa;
            double _tmp = (double) (((1000.0 * trxvutxPowerAmplifierCurrent()) * 0.16643964));
            this.trxvutxPowerAmplifierCurrentMa = _tmp;
            return this.trxvutxPowerAmplifierCurrentMa;
        }
        private Double trxvurxInstantaneousReceivedSignalStrengthDbm;
        public Double trxvurxInstantaneousReceivedSignalStrengthDbm() {
            if (this.trxvurxInstantaneousReceivedSignalStrengthDbm != null)
                return this.trxvurxInstantaneousReceivedSignalStrengthDbm;
            double _tmp = (double) (((trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort() * 0.03) - 152));
            this.trxvurxInstantaneousReceivedSignalStrengthDbm = _tmp;
            return this.trxvurxInstantaneousReceivedSignalStrengthDbm;
        }
        private Double pObc05Mw;
        public Double pObc05Mw() {
            if (this.pObc05Mw != null)
                return this.pObc05Mw;
            double _tmp = (double) (((pObc05() * 3125.0) / 6400.0));
            this.pObc05Mw = _tmp;
            return this.pObc05Mw;
        }
        private Integer statObcOnRaw;

        /**
         * bit n = 1 indicates the channel n is ON 9 firsts bits used
         */
        public Integer statObcOnRaw() {
            if (this.statObcOnRaw != null)
                return this.statObcOnRaw;
            int _tmp = (int) (statObcOn());
            this.statObcOnRaw = _tmp;
            return this.statObcOnRaw;
        }
        private Double panelTemperature6C;
        public Double panelTemperature6C() {
            if (this.panelTemperature6C != null)
                return this.panelTemperature6C;
            double _tmp = (double) ((panelTemperature6() / 1024.0));
            this.panelTemperature6C = _tmp;
            return this.panelTemperature6C;
        }
        private Long statusStatRaw;
        public Long statusStatRaw() {
            if (this.statusStatRaw != null)
                return this.statusStatRaw;
            long _tmp = (long) (statusStat());
            this.statusStatRaw = _tmp;
            return this.statusStatRaw;
        }
        private Double pObc00Mw;
        public Double pObc00Mw() {
            if (this.pObc00Mw != null)
                return this.pObc00Mw;
            double _tmp = (double) (((pObc00() * 3125.0) / 6400.0));
            this.pObc00Mw = _tmp;
            return this.pObc00Mw;
        }
        private Double trxvurxInstantaneousReceivedSignalDopplerHz;
        public Double trxvurxInstantaneousReceivedSignalDopplerHz() {
            if (this.trxvurxInstantaneousReceivedSignalDopplerHz != null)
                return this.trxvurxInstantaneousReceivedSignalDopplerHz;
            double _tmp = (double) (((trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort() * 13.552) - 22300));
            this.trxvurxInstantaneousReceivedSignalDopplerHz = _tmp;
            return this.trxvurxInstantaneousReceivedSignalDopplerHz;
        }
        private Double vObc02V;
        public Double vObc02V() {
            if (this.vObc02V != null)
                return this.vObc02V;
            double _tmp = (double) ((((vObc02() * 125.0) / 128.0) / 1000.0));
            this.vObc02V = _tmp;
            return this.vObc02V;
        }
        private Integer nbResetRaw;
        public Integer nbResetRaw() {
            if (this.nbResetRaw != null)
                return this.nbResetRaw;
            int _tmp = (int) (nbReset());
            this.nbResetRaw = _tmp;
            return this.nbResetRaw;
        }
        private Double trxvurxSupplyVoltageV;
        public Double trxvurxSupplyVoltageV() {
            if (this.trxvurxSupplyVoltageV != null)
                return this.trxvurxSupplyVoltageV;
            double _tmp = (double) ((0.00488 * trxvurxSupplyVoltage()));
            this.trxvurxSupplyVoltageV = _tmp;
            return this.trxvurxSupplyVoltageV;
        }
        private Double pObc06Mw;
        public Double pObc06Mw() {
            if (this.pObc06Mw != null)
                return this.pObc06Mw;
            double _tmp = (double) (((pObc06() * 3125.0) / 6400.0));
            this.pObc06Mw = _tmp;
            return this.pObc06Mw;
        }
        private Integer modeRaw;

        /**
         * value :
         * 0 = Startup 
         * 1 = Nominal 
         * 2 = Safety 
         * 3 = Emergency low power 8
         */
        public Integer modeRaw() {
            if (this.modeRaw != null)
                return this.modeRaw;
            int _tmp = (int) (mode());
            this.modeRaw = _tmp;
            return this.modeRaw;
        }
        private Double trxvurxLocalOscillatorTemperatureC;
        public Double trxvurxLocalOscillatorTemperatureC() {
            if (this.trxvurxLocalOscillatorTemperatureC != null)
                return this.trxvurxLocalOscillatorTemperatureC;
            double _tmp = (double) (((trxvurxLocalOscillatorTemperature() * -0.07669) + 195.6037));
            this.trxvurxLocalOscillatorTemperatureC = _tmp;
            return this.trxvurxLocalOscillatorTemperatureC;
        }
        private Long statusCmderrRaw;
        public Long statusCmderrRaw() {
            if (this.statusCmderrRaw != null)
                return this.statusCmderrRaw;
            long _tmp = (long) (statusCmderr());
            this.statusCmderrRaw = _tmp;
            return this.statusCmderrRaw;
        }
        private Integer photodiode1Raw;
        public Integer photodiode1Raw() {
            if (this.photodiode1Raw != null)
                return this.photodiode1Raw;
            int _tmp = (int) (photodiode1());
            this.photodiode1Raw = _tmp;
            return this.photodiode1Raw;
        }
        private Double pObc01Mw;
        public Double pObc01Mw() {
            if (this.pObc01Mw != null)
                return this.pObc01Mw;
            double _tmp = (double) (((pObc01() * 3125.0) / 6400.0));
            this.pObc01Mw = _tmp;
            return this.pObc01Mw;
        }
        private Integer photodiode5Raw;
        public Integer photodiode5Raw() {
            if (this.photodiode5Raw != null)
                return this.photodiode5Raw;
            int _tmp = (int) (photodiode5());
            this.photodiode5Raw = _tmp;
            return this.photodiode5Raw;
        }
        private Double trxvurxTransmitterCurrentMa;
        public Double trxvurxTransmitterCurrentMa() {
            if (this.trxvurxTransmitterCurrentMa != null)
                return this.trxvurxTransmitterCurrentMa;
            double _tmp = (double) ((trxvurxTransmitterCurrent() * 0.16643964));
            this.trxvurxTransmitterCurrentMa = _tmp;
            return this.trxvurxTransmitterCurrentMa;
        }
        private Integer rcCntCmdRaw;
        public Integer rcCntCmdRaw() {
            if (this.rcCntCmdRaw != null)
                return this.rcCntCmdRaw;
            int _tmp = (int) (rcCntCmd());
            this.rcCntCmdRaw = _tmp;
            return this.rcCntCmdRaw;
        }
        private Integer imtqSystemStateModeRaw;

        /**
         * value :
         * IDLE = 0 
         * SELFTEST = 1 
         * DETUMBLE = 2
         */
        public Integer imtqSystemStateModeRaw() {
            if (this.imtqSystemStateModeRaw != null)
                return this.imtqSystemStateModeRaw;
            int _tmp = (int) (imtqSystemStateMode());
            this.imtqSystemStateModeRaw = _tmp;
            return this.imtqSystemStateModeRaw;
        }
        private Integer statObcOcfRaw;

        /**
         * bit n = 1 indicates a overcurrent on the channel n 9 firsts bits used
         */
        public Integer statObcOcfRaw() {
            if (this.statObcOcfRaw != null)
                return this.statObcOcfRaw;
            int _tmp = (int) (statObcOcf());
            this.statObcOcfRaw = _tmp;
            return this.statObcOcfRaw;
        }
        private Double measureCoilZCurrentMa;
        public Double measureCoilZCurrentMa() {
            if (this.measureCoilZCurrentMa != null)
                return this.measureCoilZCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilZCurrent()) - 1.03)) / 0.48));
            this.measureCoilZCurrentMa = _tmp;
            return this.measureCoilZCurrentMa;
        }
        private Integer voltVd2Raw;
        public Integer voltVd2Raw() {
            if (this.voltVd2Raw != null)
                return this.voltVd2Raw;
            int _tmp = (int) (voltVd2());
            this.voltVd2Raw = _tmp;
            return this.voltVd2Raw;
        }
        private Long uptimeRaw;
        public Long uptimeRaw() {
            if (this.uptimeRaw != null)
                return this.uptimeRaw;
            long _tmp = (long) (uptime());
            this.uptimeRaw = _tmp;
            return this.uptimeRaw;
        }
        private Double voltBrdSupRawV;
        public Double voltBrdSupRawV() {
            if (this.voltBrdSupRawV != null)
                return this.voltBrdSupRawV;
            double _tmp = (double) (((voltBrdSupRaw() * 1000.0) / 819.0));
            this.voltBrdSupRawV = _tmp;
            return this.voltBrdSupRawV;
        }
        private Double measureCoilZTemperatureC;
        public Double measureCoilZTemperatureC() {
            if (this.measureCoilZTemperatureC != null)
                return this.measureCoilZTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilZTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilZTemperatureC = _tmp;
            return this.measureCoilZTemperatureC;
        }
        private Double iObc00Ma;
        public Double iObc00Ma() {
            if (this.iObc00Ma != null)
                return this.iObc00Ma;
            double _tmp = (double) (((iObc00() * 3125.0) / 20480.0));
            this.iObc00Ma = _tmp;
            return this.iObc00Ma;
        }
        private Integer rcCntWdgRaw;
        public Integer rcCntWdgRaw() {
            if (this.rcCntWdgRaw != null)
                return this.rcCntWdgRaw;
            int _tmp = (int) (rcCntWdg());
            this.rcCntWdgRaw = _tmp;
            return this.rcCntWdgRaw;
        }
        private Double pDistInputRawMw;
        public Double pDistInputRawMw() {
            if (this.pDistInputRawMw != null)
                return this.pDistInputRawMw;
            double _tmp = (double) (((pDistInputRaw() * 3125.0) / 3200.0));
            this.pDistInputRawMw = _tmp;
            return this.pDistInputRawMw;
        }
        private Double measureCoilXCurrentMa;
        public Double measureCoilXCurrentMa() {
            if (this.measureCoilXCurrentMa != null)
                return this.measureCoilXCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilXCurrent()) - 1.03)) / 2.0));
            this.measureCoilXCurrentMa = _tmp;
            return this.measureCoilXCurrentMa;
        }
        private Integer batStatRaw;
        public Integer batStatRaw() {
            if (this.batStatRaw != null)
                return this.batStatRaw;
            int _tmp = (int) (batStat());
            this.batStatRaw = _tmp;
            return this.batStatRaw;
        }
        private Integer resetOrderRaw;

        /**
         * Order by TC = 0xCA
         * No order = 0
         */
        public Integer resetOrderRaw() {
            if (this.resetOrderRaw != null)
                return this.resetOrderRaw;
            int _tmp = (int) (resetOrder());
            this.resetOrderRaw = _tmp;
            return this.resetOrderRaw;
        }
        private Double trxvutxSupplyVoltageV;
        public Double trxvutxSupplyVoltageV() {
            if (this.trxvutxSupplyVoltageV != null)
                return this.trxvutxSupplyVoltageV;
            double _tmp = (double) ((0.00488 * trxvutxSupplyVoltage()));
            this.trxvutxSupplyVoltageV = _tmp;
            return this.trxvutxSupplyVoltageV;
        }
        private Double vObc06V;
        public Double vObc06V() {
            if (this.vObc06V != null)
                return this.vObc06V;
            double _tmp = (double) ((((vObc06() * 125.0) / 128.0) / 1000.0));
            this.vObc06V = _tmp;
            return this.vObc06V;
        }
        private Double iObc03Ma;
        public Double iObc03Ma() {
            if (this.iObc03Ma != null)
                return this.iObc03Ma;
            double _tmp = (double) (((iObc03() * 3125.0) / 20480.0));
            this.iObc03Ma = _tmp;
            return this.iObc03Ma;
        }
        private Double vObc03V;
        public Double vObc03V() {
            if (this.vObc03V != null)
                return this.vObc03V;
            double _tmp = (double) ((((vObc03() * 125.0) / 128.0) / 1000.0));
            this.vObc03V = _tmp;
            return this.vObc03V;
        }
        private Double trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
        public Double trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw() {
            if (this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw != null)
                return this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
            double _tmp = (double) (((((1000.0 * trxvutxInstantaneousRfReflectedPowerFromTransmitterPort()) * trxvutxInstantaneousRfReflectedPowerFromTransmitterPort()) * 5.887) * 0.00001));
            this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw = _tmp;
            return this.trxvutxInstantaneousRfReflectedPowerFromTransmitterPortMw;
        }
        private Long nbTmSinceFirstStartRaw;
        public Long nbTmSinceFirstStartRaw() {
            if (this.nbTmSinceFirstStartRaw != null)
                return this.nbTmSinceFirstStartRaw;
            long _tmp = (long) (nbTmSinceFirstStart());
            this.nbTmSinceFirstStartRaw = _tmp;
            return this.nbTmSinceFirstStartRaw;
        }
        private Double iBattInputRawMa;
        public Double iBattInputRawMa() {
            if (this.iBattInputRawMa != null)
                return this.iBattInputRawMa;
            double _tmp = (double) ((1000.0 * ((iBattInputRaw() * 3125.0) / 10240.0)));
            this.iBattInputRawMa = _tmp;
            return this.iBattInputRawMa;
        }
        private Double panelTemperature3C;
        public Double panelTemperature3C() {
            if (this.panelTemperature3C != null)
                return this.panelTemperature3C;
            double _tmp = (double) ((panelTemperature3() / 1024.0));
            this.panelTemperature3C = _tmp;
            return this.panelTemperature3C;
        }
        private Double trxvutxLocalOscillatorTemperatureC;
        public Double trxvutxLocalOscillatorTemperatureC() {
            if (this.trxvutxLocalOscillatorTemperatureC != null)
                return this.trxvutxLocalOscillatorTemperatureC;
            double _tmp = (double) (((trxvutxLocalOscillatorTemperature() * -0.07669) + 195.6037));
            this.trxvutxLocalOscillatorTemperatureC = _tmp;
            return this.trxvutxLocalOscillatorTemperatureC;
        }
        private Integer photodiode2Raw;
        public Integer photodiode2Raw() {
            if (this.photodiode2Raw != null)
                return this.photodiode2Raw;
            int _tmp = (int) (photodiode2());
            this.photodiode2Raw = _tmp;
            return this.photodiode2Raw;
        }
        private Double iObc02Ma;
        public Double iObc02Ma() {
            if (this.iObc02Ma != null)
                return this.iObc02Ma;
            double _tmp = (double) (((iObc02() * 3125.0) / 20480.0));
            this.iObc02Ma = _tmp;
            return this.iObc02Ma;
        }
        private Integer statusStidRaw;
        public Integer statusStidRaw() {
            if (this.statusStidRaw != null)
                return this.statusStidRaw;
            int _tmp = (int) (statusStid());
            this.statusStidRaw = _tmp;
            return this.statusStidRaw;
        }
        private Double trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
        public Double trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw() {
            if (this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw != null)
                return this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
            double _tmp = (double) (((((1000.0 * trxvutxInstantaneousRfForwardPowerFromTransmitterPort()) * trxvutxInstantaneousRfForwardPowerFromTransmitterPort()) * 5.887) * 0.00001));
            this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw = _tmp;
            return this.trxvutxInstantaneousRfForwardPowerFromTransmitterPortMw;
        }
        private Integer photodiode6Raw;
        public Integer photodiode6Raw() {
            if (this.photodiode6Raw != null)
                return this.photodiode6Raw;
            int _tmp = (int) (photodiode6());
            this.photodiode6Raw = _tmp;
            return this.photodiode6Raw;
        }
        private Double iObc06Ma;
        public Double iObc06Ma() {
            if (this.iObc06Ma != null)
                return this.iObc06Ma;
            double _tmp = (double) (((iObc06() * 3125.0) / 20480.0));
            this.iObc06Ma = _tmp;
            return this.iObc06Ma;
        }
        private Integer statusRcRaw;
        public Integer statusRcRaw() {
            if (this.statusRcRaw != null)
                return this.statusRcRaw;
            int _tmp = (int) (statusRc());
            this.statusRcRaw = _tmp;
            return this.statusRcRaw;
        }
        private Integer errorRaw;
        public Integer errorRaw() {
            if (this.errorRaw != null)
                return this.errorRaw;
            int _tmp = (int) (error());
            this.errorRaw = _tmp;
            return this.errorRaw;
        }
        private Double iDistInputRawMa;
        public Double iDistInputRawMa() {
            if (this.iDistInputRawMa != null)
                return this.iDistInputRawMa;
            double _tmp = (double) (((iDistInputRaw() * 3125.0) / 10240.0));
            this.iDistInputRawMa = _tmp;
            return this.iDistInputRawMa;
        }
        private Integer photodiode4Raw;
        public Integer photodiode4Raw() {
            if (this.photodiode4Raw != null)
                return this.photodiode4Raw;
            int _tmp = (int) (photodiode4());
            this.photodiode4Raw = _tmp;
            return this.photodiode4Raw;
        }
        private Double measureCoilYCurrentMa;
        public Double measureCoilYCurrentMa() {
            if (this.measureCoilYCurrentMa != null)
                return this.measureCoilYCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilYCurrent()) - 1.03)) / 2.0));
            this.measureCoilYCurrentMa = _tmp;
            return this.measureCoilYCurrentMa;
        }
        private Double vObc01V;
        public Double vObc01V() {
            if (this.vObc01V != null)
                return this.vObc01V;
            double _tmp = (double) ((((vObc01() * 125.0) / 128.0) / 1000.0));
            this.vObc01V = _tmp;
            return this.vObc01V;
        }
        private Double pBattInputRawMw;
        public Double pBattInputRawMw() {
            if (this.pBattInputRawMw != null)
                return this.pBattInputRawMw;
            double _tmp = (double) (((pBattInputRaw() * 3125.0) / 3200.0));
            this.pBattInputRawMw = _tmp;
            return this.pBattInputRawMw;
        }
        private Double iObc01Ma;
        public Double iObc01Ma() {
            if (this.iObc01Ma != null)
                return this.iObc01Ma;
            double _tmp = (double) (((iObc01() * 3125.0) / 20480.0));
            this.iObc01Ma = _tmp;
            return this.iObc01Ma;
        }
        private Long nbTmInSdcardRaw;
        public Long nbTmInSdcardRaw() {
            if (this.nbTmInSdcardRaw != null)
                return this.nbTmInSdcardRaw;
            long _tmp = (long) (nbTmInSdcard());
            this.nbTmInSdcardRaw = _tmp;
            return this.nbTmInSdcardRaw;
        }
        private Double tempRawT;
        public Double tempRawT() {
            if (this.tempRawT != null)
                return this.tempRawT;
            double _tmp = (double) (((((tempRaw() - 1168) * 220.0) / 9.0) / 100.0));
            this.tempRawT = _tmp;
            return this.tempRawT;
        }
        private Double panelTemperature4C;
        public Double panelTemperature4C() {
            if (this.panelTemperature4C != null)
                return this.panelTemperature4C;
            double _tmp = (double) ((panelTemperature4() / 1024.0));
            this.panelTemperature4C = _tmp;
            return this.panelTemperature4C;
        }
        private Integer photodiode3Raw;
        public Integer photodiode3Raw() {
            if (this.photodiode3Raw != null)
                return this.photodiode3Raw;
            int _tmp = (int) (photodiode3());
            this.photodiode3Raw = _tmp;
            return this.photodiode3Raw;
        }
        private Double trxvutxReceiverCurrentMa;
        public Double trxvutxReceiverCurrentMa() {
            if (this.trxvutxReceiverCurrentMa != null)
                return this.trxvutxReceiverCurrentMa;
            double _tmp = (double) ((trxvutxReceiverCurrent() * 0.16643964));
            this.trxvutxReceiverCurrentMa = _tmp;
            return this.trxvutxReceiverCurrentMa;
        }
        private Integer rcCntEmlopoRaw;
        public Integer rcCntEmlopoRaw() {
            if (this.rcCntEmlopoRaw != null)
                return this.rcCntEmlopoRaw;
            int _tmp = (int) (rcCntEmlopo());
            this.rcCntEmlopoRaw = _tmp;
            return this.rcCntEmlopoRaw;
        }
        private Integer rcCntMcuRaw;
        public Integer rcCntMcuRaw() {
            if (this.rcCntMcuRaw != null)
                return this.rcCntMcuRaw;
            int _tmp = (int) (rcCntMcu());
            this.rcCntMcuRaw = _tmp;
            return this.rcCntMcuRaw;
        }
        private Integer statusBidRaw;
        public Integer statusBidRaw() {
            if (this.statusBidRaw != null)
                return this.statusBidRaw;
            int _tmp = (int) (statusBid());
            this.statusBidRaw = _tmp;
            return this.statusBidRaw;
        }
        private Integer statusIvidRaw;
        public Integer statusIvidRaw() {
            if (this.statusIvidRaw != null)
                return this.statusIvidRaw;
            int _tmp = (int) (statusIvid());
            this.statusIvidRaw = _tmp;
            return this.statusIvidRaw;
        }
        private Double panelTemperature1C;
        public Double panelTemperature1C() {
            if (this.panelTemperature1C != null)
                return this.panelTemperature1C;
            double _tmp = (double) ((panelTemperature1() / 1024.0));
            this.panelTemperature1C = _tmp;
            return this.panelTemperature1C;
        }
        private Double pObc03Mw;
        public Double pObc03Mw() {
            if (this.pObc03Mw != null)
                return this.pObc03Mw;
            double _tmp = (double) (((pObc03() * 3125.0) / 6400.0));
            this.pObc03Mw = _tmp;
            return this.pObc03Mw;
        }
        private Integer voltVd1Raw;
        public Integer voltVd1Raw() {
            if (this.voltVd1Raw != null)
                return this.voltVd1Raw;
            int _tmp = (int) (voltVd1());
            this.voltVd1Raw = _tmp;
            return this.voltVd1Raw;
        }
        private Double trxvurxPowerAmplifierCurrentMa;
        public Double trxvurxPowerAmplifierCurrentMa() {
            if (this.trxvurxPowerAmplifierCurrentMa != null)
                return this.trxvurxPowerAmplifierCurrentMa;
            double _tmp = (double) (((1000.0 * trxvurxPowerAmplifierCurrent()) * 0.16643964));
            this.trxvurxPowerAmplifierCurrentMa = _tmp;
            return this.trxvurxPowerAmplifierCurrentMa;
        }
        private Double trxvurxTotalSupplyCurrentMa;
        public Double trxvurxTotalSupplyCurrentMa() {
            if (this.trxvurxTotalSupplyCurrentMa != null)
                return this.trxvurxTotalSupplyCurrentMa;
            double _tmp = (double) ((0.16643964 * trxvurxTotalSupplyCurrent()));
            this.trxvurxTotalSupplyCurrentMa = _tmp;
            return this.trxvurxTotalSupplyCurrentMa;
        }
        private Double vObc05V;
        public Double vObc05V() {
            if (this.vObc05V != null)
                return this.vObc05V;
            double _tmp = (double) ((((vObc05() * 125.0) / 128.0) / 1000.0));
            this.vObc05V = _tmp;
            return this.vObc05V;
        }
        private Double trxvutxPowerAmplifierTemperatureC;
        public Double trxvutxPowerAmplifierTemperatureC() {
            if (this.trxvutxPowerAmplifierTemperatureC != null)
                return this.trxvutxPowerAmplifierTemperatureC;
            double _tmp = (double) (((trxvutxPowerAmplifierTemperature() * -0.07669) + 195.6037));
            this.trxvutxPowerAmplifierTemperatureC = _tmp;
            return this.trxvutxPowerAmplifierTemperatureC;
        }
        private Long nbTcSinceFirstStartRaw;
        public Long nbTcSinceFirstStartRaw() {
            if (this.nbTcSinceFirstStartRaw != null)
                return this.nbTcSinceFirstStartRaw;
            long _tmp = (long) (nbTcSinceFirstStart());
            this.nbTcSinceFirstStartRaw = _tmp;
            return this.nbTcSinceFirstStartRaw;
        }
        private Double trxvutxTransmitterCurrentMa;
        public Double trxvutxTransmitterCurrentMa() {
            if (this.trxvutxTransmitterCurrentMa != null)
                return this.trxvutxTransmitterCurrentMa;
            double _tmp = (double) ((trxvutxTransmitterCurrent() * 0.16643964));
            this.trxvutxTransmitterCurrentMa = _tmp;
            return this.trxvutxTransmitterCurrentMa;
        }
        private Double mcuTemperatureC;
        public Double mcuTemperatureC() {
            if (this.mcuTemperatureC != null)
                return this.mcuTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * mcuTemperature()) - 0.680) * -1.0) / 0.00225));
            this.mcuTemperatureC = _tmp;
            return this.mcuTemperatureC;
        }
        private Double vObc00V;
        public Double vObc00V() {
            if (this.vObc00V != null)
                return this.vObc00V;
            double _tmp = (double) ((((vObc00() * 125.0) / 128.0) / 1000.0));
            this.vObc00V = _tmp;
            return this.vObc00V;
        }
        private Long nbTcPingSinceFirstStartRaw;
        public Long nbTcPingSinceFirstStartRaw() {
            if (this.nbTcPingSinceFirstStartRaw != null)
                return this.nbTcPingSinceFirstStartRaw;
            long _tmp = (long) (nbTcPingSinceFirstStart());
            this.nbTcPingSinceFirstStartRaw = _tmp;
            return this.nbTcPingSinceFirstStartRaw;
        }
        private Integer voltVd0Raw;
        public Integer voltVd0Raw() {
            if (this.voltVd0Raw != null)
                return this.voltVd0Raw;
            int _tmp = (int) (voltVd0());
            this.voltVd0Raw = _tmp;
            return this.voltVd0Raw;
        }
        private Double batTemp2RawT;
        public Double batTemp2RawT() {
            if (this.batTemp2RawT != null)
                return this.batTemp2RawT;
            double _tmp = (double) (((batTemp2Raw() * -0.047715407918) + 98.38261483));
            this.batTemp2RawT = _tmp;
            return this.batTemp2RawT;
        }
        private Double vBattInputRawV;
        public Double vBattInputRawV() {
            if (this.vBattInputRawV != null)
                return this.vBattInputRawV;
            double _tmp = (double) ((((vBattInputRaw() * 125.0) / 128.0) / 1000.0));
            this.vBattInputRawV = _tmp;
            return this.vBattInputRawV;
        }
        private Double trxvurxPowerAmplifierTemperatureC;
        public Double trxvurxPowerAmplifierTemperatureC() {
            if (this.trxvurxPowerAmplifierTemperatureC != null)
                return this.trxvurxPowerAmplifierTemperatureC;
            double _tmp = (double) (((trxvurxPowerAmplifierTemperature() * -0.07669) + 195.6037));
            this.trxvurxPowerAmplifierTemperatureC = _tmp;
            return this.trxvurxPowerAmplifierTemperatureC;
        }
        private Integer resetCauseRaw;

        /**
         * value : 
         * 0 = Power-on; system returned from an unpowered state (e.g. power cycle). 
         * 1 = Watchdog; system was reset due to watchdog timeout, caused by a too-long delay between command interactions with the parent system. 
         * 2 = Commanded; system was reset after having received a reset command. 
         * 3 = Control system reset; an upset in the EPS control system caused a reset. 
         * 4 = Emlopo; emergency low power mode was engaged because the input voltage dropped below the threshold.
         */
        public Integer resetCauseRaw() {
            if (this.resetCauseRaw != null)
                return this.resetCauseRaw;
            int _tmp = (int) (resetCause());
            this.resetCauseRaw = _tmp;
            return this.resetCauseRaw;
        }
        private Long nbBadTcSinceFirstStartRaw;
        public Long nbBadTcSinceFirstStartRaw() {
            if (this.nbBadTcSinceFirstStartRaw != null)
                return this.nbBadTcSinceFirstStartRaw;
            long _tmp = (long) (nbBadTcSinceFirstStart());
            this.nbBadTcSinceFirstStartRaw = _tmp;
            return this.nbBadTcSinceFirstStartRaw;
        }
        private Double pObc02Mw;
        public Double pObc02Mw() {
            if (this.pObc02Mw != null)
                return this.pObc02Mw;
            double _tmp = (double) (((pObc02() * 3125.0) / 6400.0));
            this.pObc02Mw = _tmp;
            return this.pObc02Mw;
        }
        private Integer swModeRaw;

        /**
         * : mode value 
         * MODE_INIT = 0 
         * MODE_DETUMBLING = 1 
         * MODE_STANDBY = 2 
         * MODE_OPERATIONAL = 3 
         * MODE_SAFE = 4 
         * MODE_TRANSPONDER = 5
         */
        public Integer swModeRaw() {
            if (this.swModeRaw != null)
                return this.swModeRaw;
            int _tmp = (int) (swMode());
            this.swModeRaw = _tmp;
            return this.swModeRaw;
        }
        private Integer sideAAntsTemperatureRaw;
        public Integer sideAAntsTemperatureRaw() {
            if (this.sideAAntsTemperatureRaw != null)
                return this.sideAAntsTemperatureRaw;
            int _tmp = (int) (sideAAntsTemperature());
            this.sideAAntsTemperatureRaw = _tmp;
            return this.sideAAntsTemperatureRaw;
        }
        private Double panelTemperature5C;
        public Double panelTemperature5C() {
            if (this.panelTemperature5C != null)
                return this.panelTemperature5C;
            double _tmp = (double) ((panelTemperature5() / 1024.0));
            this.panelTemperature5C = _tmp;
            return this.panelTemperature5C;
        }
        private Integer sideAAntsDeploymentStatusRaw;
        public Integer sideAAntsDeploymentStatusRaw() {
            if (this.sideAAntsDeploymentStatusRaw != null)
                return this.sideAAntsDeploymentStatusRaw;
            int _tmp = (int) (sideAAntsDeploymentStatus());
            this.sideAAntsDeploymentStatusRaw = _tmp;
            return this.sideAAntsDeploymentStatusRaw;
        }
        private Double measureCoilXTemperatureC;
        public Double measureCoilXTemperatureC() {
            if (this.measureCoilXTemperatureC != null)
                return this.measureCoilXTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilXTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilXTemperatureC = _tmp;
            return this.measureCoilXTemperatureC;
        }
        private Integer confRaw;

        /**
         * value : 
         * 0 = Parameters have not been altered since the last load/save.
         * 1 = Parameters have been altered since the last load/save.
         */
        public Integer confRaw() {
            if (this.confRaw != null)
                return this.confRaw;
            int _tmp = (int) (conf());
            this.confRaw = _tmp;
            return this.confRaw;
        }
        private Integer formatSdcardOrderRaw;

        /**
         * Order to Format SdCard 0 = 0
         * Order to Format SdCard 1 = 1
         * Order to NOT Format SdCard 0 = 0xAC
         * Order to NOT Format SdCard 1 = 0xAD
         */
        public Integer formatSdcardOrderRaw() {
            if (this.formatSdcardOrderRaw != null)
                return this.formatSdcardOrderRaw;
            int _tmp = (int) (formatSdcardOrder());
            this.formatSdcardOrderRaw = _tmp;
            return this.formatSdcardOrderRaw;
        }
        private Double panelTemperature2C;
        public Double panelTemperature2C() {
            if (this.panelTemperature2C != null)
                return this.panelTemperature2C;
            double _tmp = (double) ((panelTemperature2() / 1024.0));
            this.panelTemperature2C = _tmp;
            return this.panelTemperature2C;
        }
        private Double trxvurxReceiverCurrentMa;
        public Double trxvurxReceiverCurrentMa() {
            if (this.trxvurxReceiverCurrentMa != null)
                return this.trxvurxReceiverCurrentMa;
            double _tmp = (double) ((trxvurxReceiverCurrent() * 0.16643964));
            this.trxvurxReceiverCurrentMa = _tmp;
            return this.trxvurxReceiverCurrentMa;
        }
        private Integer prevcmdElapsedRaw;
        public Integer prevcmdElapsedRaw() {
            if (this.prevcmdElapsedRaw != null)
                return this.prevcmdElapsedRaw;
            int _tmp = (int) (prevcmdElapsed());
            this.prevcmdElapsedRaw = _tmp;
            return this.prevcmdElapsedRaw;
        }
        private int swMode;
        private int lastResetReason;
        private int resetOrder;
        private int nbReset;
        private int formatSdcardOrder;
        private int deployAntennasSystem;
        private long nbTmSinceFirstStart;
        private long nbTcSinceFirstStart;
        private long nbTcPingSinceFirstStart;
        private long nbBadTcSinceFirstStart;
        private long nbTmInSdcard;
        private long trxvutxInstantaneousRfReflectedPowerFromTransmitterPort;
        private long trxvutxInstantaneousRfForwardPowerFromTransmitterPort;
        private long trxvutxSupplyVoltage;
        private long trxvutxTotalSupplyCurrent;
        private long trxvutxTransmitterCurrent;
        private long trxvutxReceiverCurrent;
        private long trxvutxPowerAmplifierCurrent;
        private long trxvutxPowerAmplifierTemperature;
        private long trxvutxLocalOscillatorTemperature;
        private long trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort;
        private long trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort;
        private long trxvurxSupplyVoltage;
        private long trxvurxTotalSupplyCurrent;
        private long trxvurxTransmitterCurrent;
        private long trxvurxReceiverCurrent;
        private long trxvurxPowerAmplifierCurrent;
        private long trxvurxPowerAmplifierTemperature;
        private long trxvurxLocalOscillatorTemperature;
        private int imtqSystemStateMode;
        private int measureCoilXCurrent;
        private int measureCoilYCurrent;
        private int measureCoilZCurrent;
        private int measureCoilXTemperature;
        private int measureCoilYTemperature;
        private int measureCoilZTemperature;
        private int mcuTemperature;
        private int sideAAntsTemperature;
        private int sideAAntsDeploymentStatus;
        private int voltBrdSupRaw;
        private int tempRaw;
        private int vDistInputRaw;
        private int iDistInputRaw;
        private int pDistInputRaw;
        private int vBattInputRaw;
        private int iBattInputRaw;
        private int pBattInputRaw;
        private int statObcOn;
        private int statObcOcf;
        private int batStat;
        private int batTemp2Raw;
        private int voltVd0;
        private int voltVd1;
        private int voltVd2;
        private int vObc00;
        private int iObc00;
        private int pObc00;
        private int vObc01;
        private int iObc01;
        private int pObc01;
        private int vObc02;
        private int iObc02;
        private int pObc02;
        private int vObc03;
        private int iObc03;
        private int pObc03;
        private int vObc05;
        private int iObc05;
        private int pObc05;
        private int vObc06;
        private int iObc06;
        private int pObc06;
        private int statusStid;
        private int statusIvid;
        private int statusRc;
        private int statusBid;
        private long statusCmderr;
        private long statusStat;
        private int mode;
        private int conf;
        private int resetCause;
        private long uptime;
        private int error;
        private int rcCntPwron;
        private int rcCntWdg;
        private int rcCntCmd;
        private int rcCntMcu;
        private int rcCntEmlopo;
        private int prevcmdElapsed;
        private int photodiode1;
        private int photodiode2;
        private int photodiode3;
        private int photodiode4;
        private int photodiode5;
        private int photodiode6;
        private int panelTemperature1;
        private int panelTemperature2;
        private int panelTemperature3;
        private int panelTemperature4;
        private int panelTemperature5;
        private int panelTemperature6;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int swMode() { return swMode; }
        public int lastResetReason() { return lastResetReason; }
        public int resetOrder() { return resetOrder; }
        public int nbReset() { return nbReset; }
        public int formatSdcardOrder() { return formatSdcardOrder; }
        public int deployAntennasSystem() { return deployAntennasSystem; }
        public long nbTmSinceFirstStart() { return nbTmSinceFirstStart; }
        public long nbTcSinceFirstStart() { return nbTcSinceFirstStart; }
        public long nbTcPingSinceFirstStart() { return nbTcPingSinceFirstStart; }
        public long nbBadTcSinceFirstStart() { return nbBadTcSinceFirstStart; }
        public long nbTmInSdcard() { return nbTmInSdcard; }
        public long trxvutxInstantaneousRfReflectedPowerFromTransmitterPort() { return trxvutxInstantaneousRfReflectedPowerFromTransmitterPort; }
        public long trxvutxInstantaneousRfForwardPowerFromTransmitterPort() { return trxvutxInstantaneousRfForwardPowerFromTransmitterPort; }
        public long trxvutxSupplyVoltage() { return trxvutxSupplyVoltage; }
        public long trxvutxTotalSupplyCurrent() { return trxvutxTotalSupplyCurrent; }
        public long trxvutxTransmitterCurrent() { return trxvutxTransmitterCurrent; }
        public long trxvutxReceiverCurrent() { return trxvutxReceiverCurrent; }
        public long trxvutxPowerAmplifierCurrent() { return trxvutxPowerAmplifierCurrent; }
        public long trxvutxPowerAmplifierTemperature() { return trxvutxPowerAmplifierTemperature; }
        public long trxvutxLocalOscillatorTemperature() { return trxvutxLocalOscillatorTemperature; }
        public long trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort() { return trxvurxInstantaneousReceivedSignalDopplerOffsetAtTheReceiverPort; }
        public long trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort() { return trxvurxInstantaneousReceivedSignalStrengthAtTheReceiverPort; }
        public long trxvurxSupplyVoltage() { return trxvurxSupplyVoltage; }
        public long trxvurxTotalSupplyCurrent() { return trxvurxTotalSupplyCurrent; }
        public long trxvurxTransmitterCurrent() { return trxvurxTransmitterCurrent; }
        public long trxvurxReceiverCurrent() { return trxvurxReceiverCurrent; }
        public long trxvurxPowerAmplifierCurrent() { return trxvurxPowerAmplifierCurrent; }
        public long trxvurxPowerAmplifierTemperature() { return trxvurxPowerAmplifierTemperature; }
        public long trxvurxLocalOscillatorTemperature() { return trxvurxLocalOscillatorTemperature; }
        public int imtqSystemStateMode() { return imtqSystemStateMode; }
        public int measureCoilXCurrent() { return measureCoilXCurrent; }
        public int measureCoilYCurrent() { return measureCoilYCurrent; }
        public int measureCoilZCurrent() { return measureCoilZCurrent; }
        public int measureCoilXTemperature() { return measureCoilXTemperature; }
        public int measureCoilYTemperature() { return measureCoilYTemperature; }
        public int measureCoilZTemperature() { return measureCoilZTemperature; }
        public int mcuTemperature() { return mcuTemperature; }
        public int sideAAntsTemperature() { return sideAAntsTemperature; }
        public int sideAAntsDeploymentStatus() { return sideAAntsDeploymentStatus; }
        public int voltBrdSupRaw() { return voltBrdSupRaw; }
        public int tempRaw() { return tempRaw; }
        public int vDistInputRaw() { return vDistInputRaw; }
        public int iDistInputRaw() { return iDistInputRaw; }
        public int pDistInputRaw() { return pDistInputRaw; }
        public int vBattInputRaw() { return vBattInputRaw; }
        public int iBattInputRaw() { return iBattInputRaw; }
        public int pBattInputRaw() { return pBattInputRaw; }
        public int statObcOn() { return statObcOn; }
        public int statObcOcf() { return statObcOcf; }
        public int batStat() { return batStat; }
        public int batTemp2Raw() { return batTemp2Raw; }
        public int voltVd0() { return voltVd0; }
        public int voltVd1() { return voltVd1; }
        public int voltVd2() { return voltVd2; }
        public int vObc00() { return vObc00; }
        public int iObc00() { return iObc00; }
        public int pObc00() { return pObc00; }
        public int vObc01() { return vObc01; }
        public int iObc01() { return iObc01; }
        public int pObc01() { return pObc01; }
        public int vObc02() { return vObc02; }
        public int iObc02() { return iObc02; }
        public int pObc02() { return pObc02; }
        public int vObc03() { return vObc03; }
        public int iObc03() { return iObc03; }
        public int pObc03() { return pObc03; }
        public int vObc05() { return vObc05; }
        public int iObc05() { return iObc05; }
        public int pObc05() { return pObc05; }
        public int vObc06() { return vObc06; }
        public int iObc06() { return iObc06; }
        public int pObc06() { return pObc06; }
        public int statusStid() { return statusStid; }
        public int statusIvid() { return statusIvid; }
        public int statusRc() { return statusRc; }
        public int statusBid() { return statusBid; }
        public long statusCmderr() { return statusCmderr; }
        public long statusStat() { return statusStat; }
        public int mode() { return mode; }
        public int conf() { return conf; }
        public int resetCause() { return resetCause; }
        public long uptime() { return uptime; }
        public int error() { return error; }
        public int rcCntPwron() { return rcCntPwron; }
        public int rcCntWdg() { return rcCntWdg; }
        public int rcCntCmd() { return rcCntCmd; }
        public int rcCntMcu() { return rcCntMcu; }
        public int rcCntEmlopo() { return rcCntEmlopo; }
        public int prevcmdElapsed() { return prevcmdElapsed; }
        public int photodiode1() { return photodiode1; }
        public int photodiode2() { return photodiode2; }
        public int photodiode3() { return photodiode3; }
        public int photodiode4() { return photodiode4; }
        public int photodiode5() { return photodiode5; }
        public int photodiode6() { return photodiode6; }
        public int panelTemperature1() { return panelTemperature1; }
        public int panelTemperature2() { return panelTemperature2; }
        public int panelTemperature3() { return panelTemperature3; }
        public int panelTemperature4() { return panelTemperature4; }
        public int panelTemperature5() { return panelTemperature5; }
        public int panelTemperature6() { return panelTemperature6; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class ObcHk extends KaitaiStruct {
        public static ObcHk fromFile(String fileName) throws IOException {
            return new ObcHk(new ByteBufferKaitaiStream(fileName));
        }

        public ObcHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public ObcHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public ObcHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.dummy = this._io.readU1();
            this.spiCommandStatus = this._io.readU1();
            this.supervisorEnableStatus = this._io.readU1();
            this.supervisorUptime = this._io.readU4be();
            this.iobcUptime = this._io.readU4be();
            this.iobcResetCount = this._io.readU4be();
            this.iobcMeasureTemperature = this._io.readU2be();
            this.iobcMeasure3v3In = this._io.readU2be();
            this.iobcMeasure3v3 = this._io.readU2be();
            this.iobcMeasure2vReference = this._io.readU2be();
            this.iobcMeasure1v8 = this._io.readU2be();
            this.iobcMeasure1v0 = this._io.readU2be();
            this.iobcMeasureCurrent3v3 = this._io.readU2be();
            this.iobcMeasureCurrent1v8 = this._io.readU2be();
            this.iobcMeasureCurrent1v0 = this._io.readU2be();
            this.iobcMeasureVoltRtc = this._io.readU2be();
            this.iobcAdcUpdateFlag = this._io.readU1();
            this.iobcCrc8 = this._io.readU1();
            this.photodiode1 = this._io.readU2be();
            this.photodiode2 = this._io.readU2be();
            this.photodiode3 = this._io.readU2be();
            this.photodiode4 = this._io.readU2be();
            this.photodiode5 = this._io.readU2be();
            this.photodiode6 = this._io.readU2be();
            this.panelTemperature1 = this._io.readS4be();
            this.panelTemperature2 = this._io.readS4be();
            this.panelTemperature3 = this._io.readS4be();
            this.panelTemperature4 = this._io.readS4be();
            this.panelTemperature5 = this._io.readS4be();
            this.panelTemperature6 = this._io.readS4be();
        }
        private Double panelTemperature6C;
        public Double panelTemperature6C() {
            if (this.panelTemperature6C != null)
                return this.panelTemperature6C;
            double _tmp = (double) ((panelTemperature6() / 1024.0));
            this.panelTemperature6C = _tmp;
            return this.panelTemperature6C;
        }
        private Integer iobcMeasureTemperatureRaw;
        public Integer iobcMeasureTemperatureRaw() {
            if (this.iobcMeasureTemperatureRaw != null)
                return this.iobcMeasureTemperatureRaw;
            int _tmp = (int) (iobcMeasureTemperature());
            this.iobcMeasureTemperatureRaw = _tmp;
            return this.iobcMeasureTemperatureRaw;
        }
        private Long supervisorUptimeRaw;
        public Long supervisorUptimeRaw() {
            if (this.supervisorUptimeRaw != null)
                return this.supervisorUptimeRaw;
            long _tmp = (long) (supervisorUptime());
            this.supervisorUptimeRaw = _tmp;
            return this.supervisorUptimeRaw;
        }
        private Integer supervisorEnableStatusRaw;
        public Integer supervisorEnableStatusRaw() {
            if (this.supervisorEnableStatusRaw != null)
                return this.supervisorEnableStatusRaw;
            int _tmp = (int) (supervisorEnableStatus());
            this.supervisorEnableStatusRaw = _tmp;
            return this.supervisorEnableStatusRaw;
        }
        private Integer iobcMeasure3v3InRaw;
        public Integer iobcMeasure3v3InRaw() {
            if (this.iobcMeasure3v3InRaw != null)
                return this.iobcMeasure3v3InRaw;
            int _tmp = (int) (iobcMeasure3v3In());
            this.iobcMeasure3v3InRaw = _tmp;
            return this.iobcMeasure3v3InRaw;
        }
        private Integer photodiode2Raw;
        public Integer photodiode2Raw() {
            if (this.photodiode2Raw != null)
                return this.photodiode2Raw;
            int _tmp = (int) (photodiode2());
            this.photodiode2Raw = _tmp;
            return this.photodiode2Raw;
        }
        private Integer iobcMeasureCurrent1v0Raw;
        public Integer iobcMeasureCurrent1v0Raw() {
            if (this.iobcMeasureCurrent1v0Raw != null)
                return this.iobcMeasureCurrent1v0Raw;
            int _tmp = (int) (iobcMeasureCurrent1v0());
            this.iobcMeasureCurrent1v0Raw = _tmp;
            return this.iobcMeasureCurrent1v0Raw;
        }
        private Double panelTemperature3C;
        public Double panelTemperature3C() {
            if (this.panelTemperature3C != null)
                return this.panelTemperature3C;
            double _tmp = (double) ((panelTemperature3() / 1024.0));
            this.panelTemperature3C = _tmp;
            return this.panelTemperature3C;
        }
        private Integer dummyRaw;
        public Integer dummyRaw() {
            if (this.dummyRaw != null)
                return this.dummyRaw;
            int _tmp = (int) (dummy());
            this.dummyRaw = _tmp;
            return this.dummyRaw;
        }
        private Integer iobcMeasureVoltRtcRaw;
        public Integer iobcMeasureVoltRtcRaw() {
            if (this.iobcMeasureVoltRtcRaw != null)
                return this.iobcMeasureVoltRtcRaw;
            int _tmp = (int) (iobcMeasureVoltRtc());
            this.iobcMeasureVoltRtcRaw = _tmp;
            return this.iobcMeasureVoltRtcRaw;
        }
        private Integer iobcMeasure1v8Raw;
        public Integer iobcMeasure1v8Raw() {
            if (this.iobcMeasure1v8Raw != null)
                return this.iobcMeasure1v8Raw;
            int _tmp = (int) (iobcMeasure1v8());
            this.iobcMeasure1v8Raw = _tmp;
            return this.iobcMeasure1v8Raw;
        }
        private Integer iobcMeasure2vReferenceRaw;
        public Integer iobcMeasure2vReferenceRaw() {
            if (this.iobcMeasure2vReferenceRaw != null)
                return this.iobcMeasure2vReferenceRaw;
            int _tmp = (int) (iobcMeasure2vReference());
            this.iobcMeasure2vReferenceRaw = _tmp;
            return this.iobcMeasure2vReferenceRaw;
        }
        private Integer iobcMeasureCurrent1v8Raw;
        public Integer iobcMeasureCurrent1v8Raw() {
            if (this.iobcMeasureCurrent1v8Raw != null)
                return this.iobcMeasureCurrent1v8Raw;
            int _tmp = (int) (iobcMeasureCurrent1v8());
            this.iobcMeasureCurrent1v8Raw = _tmp;
            return this.iobcMeasureCurrent1v8Raw;
        }
        private Integer iobcMeasure3v3Raw;
        public Integer iobcMeasure3v3Raw() {
            if (this.iobcMeasure3v3Raw != null)
                return this.iobcMeasure3v3Raw;
            int _tmp = (int) (iobcMeasure3v3());
            this.iobcMeasure3v3Raw = _tmp;
            return this.iobcMeasure3v3Raw;
        }
        private Integer photodiode6Raw;
        public Integer photodiode6Raw() {
            if (this.photodiode6Raw != null)
                return this.photodiode6Raw;
            int _tmp = (int) (photodiode6());
            this.photodiode6Raw = _tmp;
            return this.photodiode6Raw;
        }
        private Double panelTemperature4C;
        public Double panelTemperature4C() {
            if (this.panelTemperature4C != null)
                return this.panelTemperature4C;
            double _tmp = (double) ((panelTemperature4() / 1024.0));
            this.panelTemperature4C = _tmp;
            return this.panelTemperature4C;
        }
        private Double panelTemperature1C;
        public Double panelTemperature1C() {
            if (this.panelTemperature1C != null)
                return this.panelTemperature1C;
            double _tmp = (double) ((panelTemperature1() / 1024.0));
            this.panelTemperature1C = _tmp;
            return this.panelTemperature1C;
        }
        private Integer iobcAdcUpdateFlagRaw;
        public Integer iobcAdcUpdateFlagRaw() {
            if (this.iobcAdcUpdateFlagRaw != null)
                return this.iobcAdcUpdateFlagRaw;
            int _tmp = (int) (iobcAdcUpdateFlag());
            this.iobcAdcUpdateFlagRaw = _tmp;
            return this.iobcAdcUpdateFlagRaw;
        }
        private Integer photodiode4Raw;
        public Integer photodiode4Raw() {
            if (this.photodiode4Raw != null)
                return this.photodiode4Raw;
            int _tmp = (int) (photodiode4());
            this.photodiode4Raw = _tmp;
            return this.photodiode4Raw;
        }
        private Long iobcResetCountRaw;
        public Long iobcResetCountRaw() {
            if (this.iobcResetCountRaw != null)
                return this.iobcResetCountRaw;
            long _tmp = (long) (iobcResetCount());
            this.iobcResetCountRaw = _tmp;
            return this.iobcResetCountRaw;
        }
        private Long iobcUptimeRaw;
        public Long iobcUptimeRaw() {
            if (this.iobcUptimeRaw != null)
                return this.iobcUptimeRaw;
            long _tmp = (long) (iobcUptime());
            this.iobcUptimeRaw = _tmp;
            return this.iobcUptimeRaw;
        }
        private Integer photodiode3Raw;
        public Integer photodiode3Raw() {
            if (this.photodiode3Raw != null)
                return this.photodiode3Raw;
            int _tmp = (int) (photodiode3());
            this.photodiode3Raw = _tmp;
            return this.photodiode3Raw;
        }
        private Integer photodiode5Raw;
        public Integer photodiode5Raw() {
            if (this.photodiode5Raw != null)
                return this.photodiode5Raw;
            int _tmp = (int) (photodiode5());
            this.photodiode5Raw = _tmp;
            return this.photodiode5Raw;
        }
        private Double panelTemperature5C;
        public Double panelTemperature5C() {
            if (this.panelTemperature5C != null)
                return this.panelTemperature5C;
            double _tmp = (double) ((panelTemperature5() / 1024.0));
            this.panelTemperature5C = _tmp;
            return this.panelTemperature5C;
        }
        private Integer iobcMeasure1v0Raw;
        public Integer iobcMeasure1v0Raw() {
            if (this.iobcMeasure1v0Raw != null)
                return this.iobcMeasure1v0Raw;
            int _tmp = (int) (iobcMeasure1v0());
            this.iobcMeasure1v0Raw = _tmp;
            return this.iobcMeasure1v0Raw;
        }
        private Integer iobcCrc8Raw;
        public Integer iobcCrc8Raw() {
            if (this.iobcCrc8Raw != null)
                return this.iobcCrc8Raw;
            int _tmp = (int) (iobcCrc8());
            this.iobcCrc8Raw = _tmp;
            return this.iobcCrc8Raw;
        }
        private Integer photodiode1Raw;
        public Integer photodiode1Raw() {
            if (this.photodiode1Raw != null)
                return this.photodiode1Raw;
            int _tmp = (int) (photodiode1());
            this.photodiode1Raw = _tmp;
            return this.photodiode1Raw;
        }
        private Integer spiCommandStatusRaw;
        public Integer spiCommandStatusRaw() {
            if (this.spiCommandStatusRaw != null)
                return this.spiCommandStatusRaw;
            int _tmp = (int) (spiCommandStatus());
            this.spiCommandStatusRaw = _tmp;
            return this.spiCommandStatusRaw;
        }
        private Integer iobcMeasureCurrent3v3Raw;
        public Integer iobcMeasureCurrent3v3Raw() {
            if (this.iobcMeasureCurrent3v3Raw != null)
                return this.iobcMeasureCurrent3v3Raw;
            int _tmp = (int) (iobcMeasureCurrent3v3());
            this.iobcMeasureCurrent3v3Raw = _tmp;
            return this.iobcMeasureCurrent3v3Raw;
        }
        private Double panelTemperature2C;
        public Double panelTemperature2C() {
            if (this.panelTemperature2C != null)
                return this.panelTemperature2C;
            double _tmp = (double) ((panelTemperature2() / 1024.0));
            this.panelTemperature2C = _tmp;
            return this.panelTemperature2C;
        }
        private int dummy;
        private int spiCommandStatus;
        private int supervisorEnableStatus;
        private long supervisorUptime;
        private long iobcUptime;
        private long iobcResetCount;
        private int iobcMeasureTemperature;
        private int iobcMeasure3v3In;
        private int iobcMeasure3v3;
        private int iobcMeasure2vReference;
        private int iobcMeasure1v8;
        private int iobcMeasure1v0;
        private int iobcMeasureCurrent3v3;
        private int iobcMeasureCurrent1v8;
        private int iobcMeasureCurrent1v0;
        private int iobcMeasureVoltRtc;
        private int iobcAdcUpdateFlag;
        private int iobcCrc8;
        private int photodiode1;
        private int photodiode2;
        private int photodiode3;
        private int photodiode4;
        private int photodiode5;
        private int photodiode6;
        private int panelTemperature1;
        private int panelTemperature2;
        private int panelTemperature3;
        private int panelTemperature4;
        private int panelTemperature5;
        private int panelTemperature6;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int dummy() { return dummy; }
        public int spiCommandStatus() { return spiCommandStatus; }
        public int supervisorEnableStatus() { return supervisorEnableStatus; }
        public long supervisorUptime() { return supervisorUptime; }
        public long iobcUptime() { return iobcUptime; }
        public long iobcResetCount() { return iobcResetCount; }
        public int iobcMeasureTemperature() { return iobcMeasureTemperature; }
        public int iobcMeasure3v3In() { return iobcMeasure3v3In; }
        public int iobcMeasure3v3() { return iobcMeasure3v3; }
        public int iobcMeasure2vReference() { return iobcMeasure2vReference; }
        public int iobcMeasure1v8() { return iobcMeasure1v8; }
        public int iobcMeasure1v0() { return iobcMeasure1v0; }
        public int iobcMeasureCurrent3v3() { return iobcMeasureCurrent3v3; }
        public int iobcMeasureCurrent1v8() { return iobcMeasureCurrent1v8; }
        public int iobcMeasureCurrent1v0() { return iobcMeasureCurrent1v0; }
        public int iobcMeasureVoltRtc() { return iobcMeasureVoltRtc; }
        public int iobcAdcUpdateFlag() { return iobcAdcUpdateFlag; }
        public int iobcCrc8() { return iobcCrc8; }
        public int photodiode1() { return photodiode1; }
        public int photodiode2() { return photodiode2; }
        public int photodiode3() { return photodiode3; }
        public int photodiode4() { return photodiode4; }
        public int photodiode5() { return photodiode5; }
        public int photodiode6() { return photodiode6; }
        public int panelTemperature1() { return panelTemperature1; }
        public int panelTemperature2() { return panelTemperature2; }
        public int panelTemperature3() { return panelTemperature3; }
        public int panelTemperature4() { return panelTemperature4; }
        public int panelTemperature5() { return panelTemperature5; }
        public int panelTemperature6() { return panelTemperature6; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class ImtqHk extends KaitaiStruct {
        public static ImtqHk fromFile(String fileName) throws IOException {
            return new ImtqHk(new ByteBufferKaitaiStream(fileName));
        }

        public ImtqHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public ImtqHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public ImtqHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.digitaleVoltage = this._io.readU2be();
            this.analogVoltage = this._io.readU2be();
            this.digitalCurrent = this._io.readU2be();
            this.analogCurrent = this._io.readU2be();
            this.measureCoilXCurrent = this._io.readU2be();
            this.measureCoilYCurrent = this._io.readU2be();
            this.measureCoilZCurrent = this._io.readU2be();
            this.measureCoilXTemperature = this._io.readU2be();
            this.measureCoilYTemperature = this._io.readU2be();
            this.measureCoilZTemperature = this._io.readU2be();
            this.mcuTemperature = this._io.readU2be();
            this.imtqSystemStateMode = this._io.readU1();
            this.imtqSystemStateError = this._io.readU1();
            this.imtqSystemStateConfiguration = this._io.readU1();
            this.imtqSystemStateUptime = this._io.readU4be();
        }
        private Integer analogCurrentRaw;
        public Integer analogCurrentRaw() {
            if (this.analogCurrentRaw != null)
                return this.analogCurrentRaw;
            int _tmp = (int) (analogCurrent());
            this.analogCurrentRaw = _tmp;
            return this.analogCurrentRaw;
        }
        private Double measureCoilYTemperatureC;
        public Double measureCoilYTemperatureC() {
            if (this.measureCoilYTemperatureC != null)
                return this.measureCoilYTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilYTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilYTemperatureC = _tmp;
            return this.measureCoilYTemperatureC;
        }
        private Integer digitalCurrentRaw;
        public Integer digitalCurrentRaw() {
            if (this.digitalCurrentRaw != null)
                return this.digitalCurrentRaw;
            int _tmp = (int) (digitalCurrent());
            this.digitalCurrentRaw = _tmp;
            return this.digitalCurrentRaw;
        }
        private Integer imtqSystemStateModeRaw;
        public Integer imtqSystemStateModeRaw() {
            if (this.imtqSystemStateModeRaw != null)
                return this.imtqSystemStateModeRaw;
            int _tmp = (int) (imtqSystemStateMode());
            this.imtqSystemStateModeRaw = _tmp;
            return this.imtqSystemStateModeRaw;
        }
        private Double measureCoilZCurrentMa;
        public Double measureCoilZCurrentMa() {
            if (this.measureCoilZCurrentMa != null)
                return this.measureCoilZCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilZCurrent()) - 1.03)) / 0.48));
            this.measureCoilZCurrentMa = _tmp;
            return this.measureCoilZCurrentMa;
        }
        private Double measureCoilZTemperatureC;
        public Double measureCoilZTemperatureC() {
            if (this.measureCoilZTemperatureC != null)
                return this.measureCoilZTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilZTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilZTemperatureC = _tmp;
            return this.measureCoilZTemperatureC;
        }
        private Double measureCoilXCurrentMa;
        public Double measureCoilXCurrentMa() {
            if (this.measureCoilXCurrentMa != null)
                return this.measureCoilXCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilXCurrent()) - 1.03)) / 2.0));
            this.measureCoilXCurrentMa = _tmp;
            return this.measureCoilXCurrentMa;
        }
        private Double measureCoilYCurrentMa;
        public Double measureCoilYCurrentMa() {
            if (this.measureCoilYCurrentMa != null)
                return this.measureCoilYCurrentMa;
            double _tmp = (double) (((1000.0 * (((2.5 / 4095) * measureCoilYCurrent()) - 1.03)) / 2.0));
            this.measureCoilYCurrentMa = _tmp;
            return this.measureCoilYCurrentMa;
        }
        private Double digitaleVoltageV;
        public Double digitaleVoltageV() {
            if (this.digitaleVoltageV != null)
                return this.digitaleVoltageV;
            double _tmp = (double) (((2 * (2.5 / 4095)) * digitaleVoltage()));
            this.digitaleVoltageV = _tmp;
            return this.digitaleVoltageV;
        }
        private Double analogVoltageV;
        public Double analogVoltageV() {
            if (this.analogVoltageV != null)
                return this.analogVoltageV;
            double _tmp = (double) (((2 * (2.5 / 4095)) * analogVoltage()));
            this.analogVoltageV = _tmp;
            return this.analogVoltageV;
        }
        private Long imtqSystemStateUptimeRaw;
        public Long imtqSystemStateUptimeRaw() {
            if (this.imtqSystemStateUptimeRaw != null)
                return this.imtqSystemStateUptimeRaw;
            long _tmp = (long) (imtqSystemStateUptime());
            this.imtqSystemStateUptimeRaw = _tmp;
            return this.imtqSystemStateUptimeRaw;
        }
        private Double mcuTemperatureC;
        public Double mcuTemperatureC() {
            if (this.mcuTemperatureC != null)
                return this.mcuTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * mcuTemperature()) - 0.680) * -1.0) / 0.00225));
            this.mcuTemperatureC = _tmp;
            return this.mcuTemperatureC;
        }
        private Integer imtqSystemStateConfigurationRaw;
        public Integer imtqSystemStateConfigurationRaw() {
            if (this.imtqSystemStateConfigurationRaw != null)
                return this.imtqSystemStateConfigurationRaw;
            int _tmp = (int) (imtqSystemStateConfiguration());
            this.imtqSystemStateConfigurationRaw = _tmp;
            return this.imtqSystemStateConfigurationRaw;
        }
        private Double measureCoilXTemperatureC;
        public Double measureCoilXTemperatureC() {
            if (this.measureCoilXTemperatureC != null)
                return this.measureCoilXTemperatureC;
            double _tmp = (double) ((((((2.5 / 4095) * measureCoilXTemperature()) - 1.567) * -1.0) / 0.0081));
            this.measureCoilXTemperatureC = _tmp;
            return this.measureCoilXTemperatureC;
        }
        private Integer imtqSystemStateErrorRaw;
        public Integer imtqSystemStateErrorRaw() {
            if (this.imtqSystemStateErrorRaw != null)
                return this.imtqSystemStateErrorRaw;
            int _tmp = (int) (imtqSystemStateError());
            this.imtqSystemStateErrorRaw = _tmp;
            return this.imtqSystemStateErrorRaw;
        }
        private int digitaleVoltage;
        private int analogVoltage;
        private int digitalCurrent;
        private int analogCurrent;
        private int measureCoilXCurrent;
        private int measureCoilYCurrent;
        private int measureCoilZCurrent;
        private int measureCoilXTemperature;
        private int measureCoilYTemperature;
        private int measureCoilZTemperature;
        private int mcuTemperature;
        private int imtqSystemStateMode;
        private int imtqSystemStateError;
        private int imtqSystemStateConfiguration;
        private long imtqSystemStateUptime;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int digitaleVoltage() { return digitaleVoltage; }
        public int analogVoltage() { return analogVoltage; }
        public int digitalCurrent() { return digitalCurrent; }
        public int analogCurrent() { return analogCurrent; }
        public int measureCoilXCurrent() { return measureCoilXCurrent; }
        public int measureCoilYCurrent() { return measureCoilYCurrent; }
        public int measureCoilZCurrent() { return measureCoilZCurrent; }
        public int measureCoilXTemperature() { return measureCoilXTemperature; }
        public int measureCoilYTemperature() { return measureCoilYTemperature; }
        public int measureCoilZTemperature() { return measureCoilZTemperature; }
        public int mcuTemperature() { return mcuTemperature; }
        public int imtqSystemStateMode() { return imtqSystemStateMode; }
        public int imtqSystemStateError() { return imtqSystemStateError; }
        public int imtqSystemStateConfiguration() { return imtqSystemStateConfiguration; }
        public long imtqSystemStateUptime() { return imtqSystemStateUptime; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class PacketSecondaryHeader extends KaitaiStruct {
        public static PacketSecondaryHeader fromFile(String fileName) throws IOException {
            return new PacketSecondaryHeader(new ByteBufferKaitaiStream(fileName));
        }

        public PacketSecondaryHeader(KaitaiStream _io) {
            this(_io, null, null);
        }

        public PacketSecondaryHeader(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public PacketSecondaryHeader(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.tmPacketPusVersionNumber = this._io.readBitsInt(4);
            this.spacecraftTimeReferenceStatus = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.serviceTypeId = this._io.readU1();
            this.messageSubtypeId = this._io.readU1();
            this.messageTypeCounter = this._io.readU2be();
            this.destinationId = this._io.readU2be();
            this.time = this._io.readU4be();
            this.dummy1 = this._io.readU2be();
            this.dummy2 = this._io.readU1();
            this.sid = this._io.readU1();
        }
        private long tmPacketPusVersionNumber;
        private long spacecraftTimeReferenceStatus;
        private int serviceTypeId;
        private int messageSubtypeId;
        private int messageTypeCounter;
        private int destinationId;
        private long time;
        private int dummy1;
        private int dummy2;
        private int sid;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public long tmPacketPusVersionNumber() { return tmPacketPusVersionNumber; }
        public long spacecraftTimeReferenceStatus() { return spacecraftTimeReferenceStatus; }
        public int serviceTypeId() { return serviceTypeId; }
        public int messageSubtypeId() { return messageSubtypeId; }
        public int messageTypeCounter() { return messageTypeCounter; }
        public int destinationId() { return destinationId; }
        public long time() { return time; }
        public int dummy1() { return dummy1; }
        public int dummy2() { return dummy2; }
        public int sid() { return sid; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class MsgOrUnknow extends KaitaiStruct {
        public static MsgOrUnknow fromFile(String fileName) throws IOException {
            return new MsgOrUnknow(new ByteBufferKaitaiStream(fileName));
        }

        public MsgOrUnknow(KaitaiStream _io) {
            this(_io, null, null);
        }

        public MsgOrUnknow(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public MsgOrUnknow(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.data = this._io.readBytesFull();
        }
        private byte[] dataByte;
        public byte[] dataByte() {
            if (this.dataByte != null)
                return this.dataByte;
            this.dataByte = data();
            return this.dataByte;
        }
        private byte[] data;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public byte[] data() { return data; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class CallsignRaw extends KaitaiStruct {
        public static CallsignRaw fromFile(String fileName) throws IOException {
            return new CallsignRaw(new ByteBufferKaitaiStream(fileName));
        }

        public CallsignRaw(KaitaiStream _io) {
            this(_io, null, null);
        }

        public CallsignRaw(KaitaiStream _io, Uvsqsat.Ax25Header _parent) {
            this(_io, _parent, null);
        }

        public CallsignRaw(KaitaiStream _io, Uvsqsat.Ax25Header _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this._raw__raw_callsignRor = this._io.readBytes(6);
            this._raw_callsignRor = KaitaiStream.processRotateLeft(this._raw__raw_callsignRor, 8 - (1), 1);
            KaitaiStream _io__raw_callsignRor = new ByteBufferKaitaiStream(_raw_callsignRor);
            this.callsignRor = new Callsign(_io__raw_callsignRor, this, _root);
        }
        private Callsign callsignRor;
        private Uvsqsat _root;
        private Uvsqsat.Ax25Header _parent;
        private byte[] _raw__raw_callsignRor;
        private byte[] _raw_callsignRor;
        public Callsign callsignRor() { return callsignRor; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.Ax25Header _parent() { return _parent; }
        public byte[] _raw__raw_callsignRor() { return _raw__raw_callsignRor; }
        public byte[] _raw_callsignRor() { return _raw_callsignRor; }
    }
    public static class IepsHkStatus extends KaitaiStruct {
        public static IepsHkStatus fromFile(String fileName) throws IOException {
            return new IepsHkStatus(new ByteBufferKaitaiStream(fileName));
        }

        public IepsHkStatus(KaitaiStream _io) {
            this(_io, null, null);
        }

        public IepsHkStatus(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public IepsHkStatus(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.hKStid = this._io.readU1();
            this.hKIvid = this._io.readU1();
            this.hKRc = this._io.readU1();
            this.hKBid = this._io.readU1();
            this.hKCmderr = this._io.readBitsInt(4);
            this.hKStat = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.voltBrdSupRaw = this._io.readU2be();
            this.tempRaw = this._io.readU2be();
            this.vDistInputRaw = this._io.readU2be();
            this.iDistInputRaw = this._io.readU2be();
            this.pDistInputRaw = this._io.readU2be();
            this.vBattInputRaw = this._io.readU2be();
            this.iBattInputRaw = this._io.readU2be();
            this.pBattInputRaw = this._io.readU2be();
            this.statObcOn = this._io.readU2be();
            this.statObcOcf = this._io.readU2be();
            this.batStat = this._io.readU2be();
            this.batTemp2Raw = this._io.readU2be();
            this.voltVd0 = this._io.readU2be();
            this.voltVd1 = this._io.readU2be();
            this.voltVd2 = this._io.readU2be();
            this.vObc00 = this._io.readU2be();
            this.iObc00 = this._io.readU2be();
            this.pObc00 = this._io.readU2be();
            this.vObc01 = this._io.readU2be();
            this.iObc01 = this._io.readU2be();
            this.pObc01 = this._io.readU2be();
            this.vObc02 = this._io.readU2be();
            this.iObc02 = this._io.readU2be();
            this.pObc02 = this._io.readU2be();
            this.vObc03 = this._io.readU2be();
            this.iObc03 = this._io.readU2be();
            this.pObc03 = this._io.readU2be();
            this.vObc05 = this._io.readU2be();
            this.iObc05 = this._io.readU2be();
            this.pObc05 = this._io.readU2be();
            this.vObc06 = this._io.readU2be();
            this.iObc06 = this._io.readU2be();
            this.pObc06 = this._io.readU2be();
            this.cc1 = this._io.readBytes(8);
            this.cc2 = this._io.readBytes(8);
            this.cc3 = this._io.readBytes(8);
            this.statusStid = this._io.readU1();
            this.statusIvid = this._io.readU1();
            this.statusRc = this._io.readU1();
            this.statusBid = this._io.readU1();
            this.statusCmderr = this._io.readBitsInt(4);
            this.statusStat = this._io.readBitsInt(4);
            this._io.alignToByte();
            this.mode = this._io.readU1();
            this.conf = this._io.readU1();
            this.resetCause = this._io.readU1();
            this.uptime = this._io.readU4be();
            this.error = this._io.readU2be();
            this.rcCntPwron = this._io.readU2be();
            this.rcCntWdg = this._io.readU2be();
            this.rcCntCmd = this._io.readU2be();
            this.rcCntMcu = this._io.readU2be();
            this.rcCntEmlopo = this._io.readU2be();
            this.prevcmdElapsed = this._io.readU2be();
        }
        private Integer rcCntPwronRaw;
        public Integer rcCntPwronRaw() {
            if (this.rcCntPwronRaw != null)
                return this.rcCntPwronRaw;
            int _tmp = (int) (rcCntPwron());
            this.rcCntPwronRaw = _tmp;
            return this.rcCntPwronRaw;
        }
        private Double vDistInputRawV;
        public Double vDistInputRawV() {
            if (this.vDistInputRawV != null)
                return this.vDistInputRawV;
            double _tmp = (double) ((((vDistInputRaw() * 125.0) / 128.0) / 1000.0));
            this.vDistInputRawV = _tmp;
            return this.vDistInputRawV;
        }
        private Double iObc05Ma;
        public Double iObc05Ma() {
            if (this.iObc05Ma != null)
                return this.iObc05Ma;
            double _tmp = (double) (((iObc05() * 3125.0) / 20480.0));
            this.iObc05Ma = _tmp;
            return this.iObc05Ma;
        }
        private Double pObc05Mw;
        public Double pObc05Mw() {
            if (this.pObc05Mw != null)
                return this.pObc05Mw;
            double _tmp = (double) (((pObc05() * 3125.0) / 6400.0));
            this.pObc05Mw = _tmp;
            return this.pObc05Mw;
        }
        private Integer statObcOnRaw;
        public Integer statObcOnRaw() {
            if (this.statObcOnRaw != null)
                return this.statObcOnRaw;
            int _tmp = (int) (statObcOn());
            this.statObcOnRaw = _tmp;
            return this.statObcOnRaw;
        }
        private Long statusStatRaw;
        public Long statusStatRaw() {
            if (this.statusStatRaw != null)
                return this.statusStatRaw;
            long _tmp = (long) (statusStat());
            this.statusStatRaw = _tmp;
            return this.statusStatRaw;
        }
        private Integer hKRcRaw;
        public Integer hKRcRaw() {
            if (this.hKRcRaw != null)
                return this.hKRcRaw;
            int _tmp = (int) (hKRc());
            this.hKRcRaw = _tmp;
            return this.hKRcRaw;
        }
        private Double pObc00Mw;
        public Double pObc00Mw() {
            if (this.pObc00Mw != null)
                return this.pObc00Mw;
            double _tmp = (double) (((pObc00() * 3125.0) / 6400.0));
            this.pObc00Mw = _tmp;
            return this.pObc00Mw;
        }
        private Double vObc02V;
        public Double vObc02V() {
            if (this.vObc02V != null)
                return this.vObc02V;
            double _tmp = (double) ((((vObc02() * 125.0) / 128.0) / 1000.0));
            this.vObc02V = _tmp;
            return this.vObc02V;
        }
        private Double pObc06Mw;
        public Double pObc06Mw() {
            if (this.pObc06Mw != null)
                return this.pObc06Mw;
            double _tmp = (double) (((pObc06() * 3125.0) / 6400.0));
            this.pObc06Mw = _tmp;
            return this.pObc06Mw;
        }
        private Integer modeRaw;
        public Integer modeRaw() {
            if (this.modeRaw != null)
                return this.modeRaw;
            int _tmp = (int) (mode());
            this.modeRaw = _tmp;
            return this.modeRaw;
        }
        private Long statusCmderrRaw;
        public Long statusCmderrRaw() {
            if (this.statusCmderrRaw != null)
                return this.statusCmderrRaw;
            long _tmp = (long) (statusCmderr());
            this.statusCmderrRaw = _tmp;
            return this.statusCmderrRaw;
        }
        private Double pObc01Mw;
        public Double pObc01Mw() {
            if (this.pObc01Mw != null)
                return this.pObc01Mw;
            double _tmp = (double) (((pObc01() * 3125.0) / 6400.0));
            this.pObc01Mw = _tmp;
            return this.pObc01Mw;
        }
        private Integer rcCntCmdRaw;
        public Integer rcCntCmdRaw() {
            if (this.rcCntCmdRaw != null)
                return this.rcCntCmdRaw;
            int _tmp = (int) (rcCntCmd());
            this.rcCntCmdRaw = _tmp;
            return this.rcCntCmdRaw;
        }
        private Integer statObcOcfRaw;
        public Integer statObcOcfRaw() {
            if (this.statObcOcfRaw != null)
                return this.statObcOcfRaw;
            int _tmp = (int) (statObcOcf());
            this.statObcOcfRaw = _tmp;
            return this.statObcOcfRaw;
        }
        private Integer voltVd2Raw;
        public Integer voltVd2Raw() {
            if (this.voltVd2Raw != null)
                return this.voltVd2Raw;
            int _tmp = (int) (voltVd2());
            this.voltVd2Raw = _tmp;
            return this.voltVd2Raw;
        }
        private Long uptimeRaw;
        public Long uptimeRaw() {
            if (this.uptimeRaw != null)
                return this.uptimeRaw;
            long _tmp = (long) (uptime());
            this.uptimeRaw = _tmp;
            return this.uptimeRaw;
        }
        private Double voltBrdSupRawV;
        public Double voltBrdSupRawV() {
            if (this.voltBrdSupRawV != null)
                return this.voltBrdSupRawV;
            double _tmp = (double) (((voltBrdSupRaw() * 1000.0) / 819.0));
            this.voltBrdSupRawV = _tmp;
            return this.voltBrdSupRawV;
        }
        private Double iObc00Ma;
        public Double iObc00Ma() {
            if (this.iObc00Ma != null)
                return this.iObc00Ma;
            double _tmp = (double) (((iObc00() * 3125.0) / 20480.0));
            this.iObc00Ma = _tmp;
            return this.iObc00Ma;
        }
        private Integer rcCntWdgRaw;
        public Integer rcCntWdgRaw() {
            if (this.rcCntWdgRaw != null)
                return this.rcCntWdgRaw;
            int _tmp = (int) (rcCntWdg());
            this.rcCntWdgRaw = _tmp;
            return this.rcCntWdgRaw;
        }
        private Double pDistInputRawMw;
        public Double pDistInputRawMw() {
            if (this.pDistInputRawMw != null)
                return this.pDistInputRawMw;
            double _tmp = (double) (((pDistInputRaw() * 3125.0) / 3200.0));
            this.pDistInputRawMw = _tmp;
            return this.pDistInputRawMw;
        }
        private Integer batStatRaw;
        public Integer batStatRaw() {
            if (this.batStatRaw != null)
                return this.batStatRaw;
            int _tmp = (int) (batStat());
            this.batStatRaw = _tmp;
            return this.batStatRaw;
        }
        private Double vObc06V;
        public Double vObc06V() {
            if (this.vObc06V != null)
                return this.vObc06V;
            double _tmp = (double) ((((vObc06() * 125.0) / 128.0) / 1000.0));
            this.vObc06V = _tmp;
            return this.vObc06V;
        }
        private Double iObc03Ma;
        public Double iObc03Ma() {
            if (this.iObc03Ma != null)
                return this.iObc03Ma;
            double _tmp = (double) (((iObc03() * 3125.0) / 20480.0));
            this.iObc03Ma = _tmp;
            return this.iObc03Ma;
        }
        private Double vObc03V;
        public Double vObc03V() {
            if (this.vObc03V != null)
                return this.vObc03V;
            double _tmp = (double) ((((vObc03() * 125.0) / 128.0) / 1000.0));
            this.vObc03V = _tmp;
            return this.vObc03V;
        }
        private Integer hKBidRaw;
        public Integer hKBidRaw() {
            if (this.hKBidRaw != null)
                return this.hKBidRaw;
            int _tmp = (int) (hKBid());
            this.hKBidRaw = _tmp;
            return this.hKBidRaw;
        }
        private Double iBattInputRawMa;
        public Double iBattInputRawMa() {
            if (this.iBattInputRawMa != null)
                return this.iBattInputRawMa;
            double _tmp = (double) ((1000.0 * ((iBattInputRaw() * 3125.0) / 10240.0)));
            this.iBattInputRawMa = _tmp;
            return this.iBattInputRawMa;
        }
        private Integer hKIvidRaw;
        public Integer hKIvidRaw() {
            if (this.hKIvidRaw != null)
                return this.hKIvidRaw;
            int _tmp = (int) (hKIvid());
            this.hKIvidRaw = _tmp;
            return this.hKIvidRaw;
        }
        private Double iObc02Ma;
        public Double iObc02Ma() {
            if (this.iObc02Ma != null)
                return this.iObc02Ma;
            double _tmp = (double) (((iObc02() * 3125.0) / 20480.0));
            this.iObc02Ma = _tmp;
            return this.iObc02Ma;
        }
        private Integer statusStidRaw;
        public Integer statusStidRaw() {
            if (this.statusStidRaw != null)
                return this.statusStidRaw;
            int _tmp = (int) (statusStid());
            this.statusStidRaw = _tmp;
            return this.statusStidRaw;
        }
        private Double iObc06Ma;
        public Double iObc06Ma() {
            if (this.iObc06Ma != null)
                return this.iObc06Ma;
            double _tmp = (double) (((iObc06() * 3125.0) / 20480.0));
            this.iObc06Ma = _tmp;
            return this.iObc06Ma;
        }
        private Integer statusRcRaw;
        public Integer statusRcRaw() {
            if (this.statusRcRaw != null)
                return this.statusRcRaw;
            int _tmp = (int) (statusRc());
            this.statusRcRaw = _tmp;
            return this.statusRcRaw;
        }
        private byte[] cc2Byte;
        public byte[] cc2Byte() {
            if (this.cc2Byte != null)
                return this.cc2Byte;
            this.cc2Byte = cc2();
            return this.cc2Byte;
        }
        private Integer errorRaw;
        public Integer errorRaw() {
            if (this.errorRaw != null)
                return this.errorRaw;
            int _tmp = (int) (error());
            this.errorRaw = _tmp;
            return this.errorRaw;
        }
        private Double iDistInputRawMa;
        public Double iDistInputRawMa() {
            if (this.iDistInputRawMa != null)
                return this.iDistInputRawMa;
            double _tmp = (double) (((iDistInputRaw() * 3125.0) / 10240.0));
            this.iDistInputRawMa = _tmp;
            return this.iDistInputRawMa;
        }
        private Double vObc01V;
        public Double vObc01V() {
            if (this.vObc01V != null)
                return this.vObc01V;
            double _tmp = (double) ((((vObc01() * 125.0) / 128.0) / 1000.0));
            this.vObc01V = _tmp;
            return this.vObc01V;
        }
        private Double pBattInputRawMw;
        public Double pBattInputRawMw() {
            if (this.pBattInputRawMw != null)
                return this.pBattInputRawMw;
            double _tmp = (double) (((pBattInputRaw() * 3125.0) / 3200.0));
            this.pBattInputRawMw = _tmp;
            return this.pBattInputRawMw;
        }
        private Double iObc01Ma;
        public Double iObc01Ma() {
            if (this.iObc01Ma != null)
                return this.iObc01Ma;
            double _tmp = (double) (((iObc01() * 3125.0) / 20480.0));
            this.iObc01Ma = _tmp;
            return this.iObc01Ma;
        }
        private Double tempRawT;
        public Double tempRawT() {
            if (this.tempRawT != null)
                return this.tempRawT;
            double _tmp = (double) (((((tempRaw() - 1168) * 220.0) / 9.0) / 100.0));
            this.tempRawT = _tmp;
            return this.tempRawT;
        }
        private byte[] cc1Byte;
        public byte[] cc1Byte() {
            if (this.cc1Byte != null)
                return this.cc1Byte;
            this.cc1Byte = cc1();
            return this.cc1Byte;
        }
        private Integer rcCntEmlopoRaw;
        public Integer rcCntEmlopoRaw() {
            if (this.rcCntEmlopoRaw != null)
                return this.rcCntEmlopoRaw;
            int _tmp = (int) (rcCntEmlopo());
            this.rcCntEmlopoRaw = _tmp;
            return this.rcCntEmlopoRaw;
        }
        private Integer rcCntMcuRaw;
        public Integer rcCntMcuRaw() {
            if (this.rcCntMcuRaw != null)
                return this.rcCntMcuRaw;
            int _tmp = (int) (rcCntMcu());
            this.rcCntMcuRaw = _tmp;
            return this.rcCntMcuRaw;
        }
        private Integer statusBidRaw;
        public Integer statusBidRaw() {
            if (this.statusBidRaw != null)
                return this.statusBidRaw;
            int _tmp = (int) (statusBid());
            this.statusBidRaw = _tmp;
            return this.statusBidRaw;
        }
        private Integer statusIvidRaw;
        public Integer statusIvidRaw() {
            if (this.statusIvidRaw != null)
                return this.statusIvidRaw;
            int _tmp = (int) (statusIvid());
            this.statusIvidRaw = _tmp;
            return this.statusIvidRaw;
        }
        private Double pObc03Mw;
        public Double pObc03Mw() {
            if (this.pObc03Mw != null)
                return this.pObc03Mw;
            double _tmp = (double) (((pObc03() * 3125.0) / 6400.0));
            this.pObc03Mw = _tmp;
            return this.pObc03Mw;
        }
        private Integer voltVd1Raw;
        public Integer voltVd1Raw() {
            if (this.voltVd1Raw != null)
                return this.voltVd1Raw;
            int _tmp = (int) (voltVd1());
            this.voltVd1Raw = _tmp;
            return this.voltVd1Raw;
        }
        private byte[] cc3Byte;
        public byte[] cc3Byte() {
            if (this.cc3Byte != null)
                return this.cc3Byte;
            this.cc3Byte = cc3();
            return this.cc3Byte;
        }
        private Double vObc05V;
        public Double vObc05V() {
            if (this.vObc05V != null)
                return this.vObc05V;
            double _tmp = (double) ((((vObc05() * 125.0) / 128.0) / 1000.0));
            this.vObc05V = _tmp;
            return this.vObc05V;
        }
        private Double vObc00V;
        public Double vObc00V() {
            if (this.vObc00V != null)
                return this.vObc00V;
            double _tmp = (double) ((((vObc00() * 125.0) / 128.0) / 1000.0));
            this.vObc00V = _tmp;
            return this.vObc00V;
        }
        private Integer voltVd0Raw;
        public Integer voltVd0Raw() {
            if (this.voltVd0Raw != null)
                return this.voltVd0Raw;
            int _tmp = (int) (voltVd0());
            this.voltVd0Raw = _tmp;
            return this.voltVd0Raw;
        }
        private Long hKCmderrRaw;
        public Long hKCmderrRaw() {
            if (this.hKCmderrRaw != null)
                return this.hKCmderrRaw;
            long _tmp = (long) (hKCmderr());
            this.hKCmderrRaw = _tmp;
            return this.hKCmderrRaw;
        }
        private Double batTemp2RawT;
        public Double batTemp2RawT() {
            if (this.batTemp2RawT != null)
                return this.batTemp2RawT;
            double _tmp = (double) (((batTemp2Raw() * -0.047715407918) + 98.38261483));
            this.batTemp2RawT = _tmp;
            return this.batTemp2RawT;
        }
        private Double vBattInputRawV;
        public Double vBattInputRawV() {
            if (this.vBattInputRawV != null)
                return this.vBattInputRawV;
            double _tmp = (double) ((((vBattInputRaw() * 125.0) / 128.0) / 1000.0));
            this.vBattInputRawV = _tmp;
            return this.vBattInputRawV;
        }
        private Integer resetCauseRaw;
        public Integer resetCauseRaw() {
            if (this.resetCauseRaw != null)
                return this.resetCauseRaw;
            int _tmp = (int) (resetCause());
            this.resetCauseRaw = _tmp;
            return this.resetCauseRaw;
        }
        private Integer hKStidRaw;
        public Integer hKStidRaw() {
            if (this.hKStidRaw != null)
                return this.hKStidRaw;
            int _tmp = (int) (hKStid());
            this.hKStidRaw = _tmp;
            return this.hKStidRaw;
        }
        private Double pObc02Mw;
        public Double pObc02Mw() {
            if (this.pObc02Mw != null)
                return this.pObc02Mw;
            double _tmp = (double) (((pObc02() * 3125.0) / 6400.0));
            this.pObc02Mw = _tmp;
            return this.pObc02Mw;
        }
        private Long hKStatRaw;
        public Long hKStatRaw() {
            if (this.hKStatRaw != null)
                return this.hKStatRaw;
            long _tmp = (long) (hKStat());
            this.hKStatRaw = _tmp;
            return this.hKStatRaw;
        }
        private Integer confRaw;
        public Integer confRaw() {
            if (this.confRaw != null)
                return this.confRaw;
            int _tmp = (int) (conf());
            this.confRaw = _tmp;
            return this.confRaw;
        }
        private Integer prevcmdElapsedRaw;
        public Integer prevcmdElapsedRaw() {
            if (this.prevcmdElapsedRaw != null)
                return this.prevcmdElapsedRaw;
            int _tmp = (int) (prevcmdElapsed());
            this.prevcmdElapsedRaw = _tmp;
            return this.prevcmdElapsedRaw;
        }
        private int hKStid;
        private int hKIvid;
        private int hKRc;
        private int hKBid;
        private long hKCmderr;
        private long hKStat;
        private int voltBrdSupRaw;
        private int tempRaw;
        private int vDistInputRaw;
        private int iDistInputRaw;
        private int pDistInputRaw;
        private int vBattInputRaw;
        private int iBattInputRaw;
        private int pBattInputRaw;
        private int statObcOn;
        private int statObcOcf;
        private int batStat;
        private int batTemp2Raw;
        private int voltVd0;
        private int voltVd1;
        private int voltVd2;
        private int vObc00;
        private int iObc00;
        private int pObc00;
        private int vObc01;
        private int iObc01;
        private int pObc01;
        private int vObc02;
        private int iObc02;
        private int pObc02;
        private int vObc03;
        private int iObc03;
        private int pObc03;
        private int vObc05;
        private int iObc05;
        private int pObc05;
        private int vObc06;
        private int iObc06;
        private int pObc06;
        private byte[] cc1;
        private byte[] cc2;
        private byte[] cc3;
        private int statusStid;
        private int statusIvid;
        private int statusRc;
        private int statusBid;
        private long statusCmderr;
        private long statusStat;
        private int mode;
        private int conf;
        private int resetCause;
        private long uptime;
        private int error;
        private int rcCntPwron;
        private int rcCntWdg;
        private int rcCntCmd;
        private int rcCntMcu;
        private int rcCntEmlopo;
        private int prevcmdElapsed;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int hKStid() { return hKStid; }
        public int hKIvid() { return hKIvid; }
        public int hKRc() { return hKRc; }
        public int hKBid() { return hKBid; }
        public long hKCmderr() { return hKCmderr; }
        public long hKStat() { return hKStat; }
        public int voltBrdSupRaw() { return voltBrdSupRaw; }
        public int tempRaw() { return tempRaw; }
        public int vDistInputRaw() { return vDistInputRaw; }
        public int iDistInputRaw() { return iDistInputRaw; }
        public int pDistInputRaw() { return pDistInputRaw; }
        public int vBattInputRaw() { return vBattInputRaw; }
        public int iBattInputRaw() { return iBattInputRaw; }
        public int pBattInputRaw() { return pBattInputRaw; }
        public int statObcOn() { return statObcOn; }
        public int statObcOcf() { return statObcOcf; }
        public int batStat() { return batStat; }
        public int batTemp2Raw() { return batTemp2Raw; }
        public int voltVd0() { return voltVd0; }
        public int voltVd1() { return voltVd1; }
        public int voltVd2() { return voltVd2; }
        public int vObc00() { return vObc00; }
        public int iObc00() { return iObc00; }
        public int pObc00() { return pObc00; }
        public int vObc01() { return vObc01; }
        public int iObc01() { return iObc01; }
        public int pObc01() { return pObc01; }
        public int vObc02() { return vObc02; }
        public int iObc02() { return iObc02; }
        public int pObc02() { return pObc02; }
        public int vObc03() { return vObc03; }
        public int iObc03() { return iObc03; }
        public int pObc03() { return pObc03; }
        public int vObc05() { return vObc05; }
        public int iObc05() { return iObc05; }
        public int pObc05() { return pObc05; }
        public int vObc06() { return vObc06; }
        public int iObc06() { return iObc06; }
        public int pObc06() { return pObc06; }
        public byte[] cc1() { return cc1; }
        public byte[] cc2() { return cc2; }
        public byte[] cc3() { return cc3; }
        public int statusStid() { return statusStid; }
        public int statusIvid() { return statusIvid; }
        public int statusRc() { return statusRc; }
        public int statusBid() { return statusBid; }
        public long statusCmderr() { return statusCmderr; }
        public long statusStat() { return statusStat; }
        public int mode() { return mode; }
        public int conf() { return conf; }
        public int resetCause() { return resetCause; }
        public long uptime() { return uptime; }
        public int error() { return error; }
        public int rcCntPwron() { return rcCntPwron; }
        public int rcCntWdg() { return rcCntWdg; }
        public int rcCntCmd() { return rcCntCmd; }
        public int rcCntMcu() { return rcCntMcu; }
        public int rcCntEmlopo() { return rcCntEmlopo; }
        public int prevcmdElapsed() { return prevcmdElapsed; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    public static class AntsHk extends KaitaiStruct {
        public static AntsHk fromFile(String fileName) throws IOException {
            return new AntsHk(new ByteBufferKaitaiStream(fileName));
        }

        public AntsHk(KaitaiStream _io) {
            this(_io, null, null);
        }

        public AntsHk(KaitaiStream _io, Uvsqsat.UiFrame _parent) {
            this(_io, _parent, null);
        }

        public AntsHk(KaitaiStream _io, Uvsqsat.UiFrame _parent, Uvsqsat _root) {
            super(_io);
            this._parent = _parent;
            this._root = _root;
            _read();
        }
        private void _read() {
            this.sideAAntsTemperature = this._io.readU2be();
            this.sideAAntsDeploymentStatus = this._io.readU2be();
            this.sideAAntsUptime = this._io.readU4be();
            this.sideADeploymentCountAntenna1 = this._io.readU1();
            this.sideADeploymentCountAntenna2 = this._io.readU1();
            this.sideADeploymentCountAntenna3 = this._io.readU1();
            this.sideADeploymentCountAntenna4 = this._io.readU1();
            this.sideADeploymentTimeAntenna1 = this._io.readU2be();
            this.sideADeploymentTimeAntenna2 = this._io.readU2be();
            this.sideADeploymentTimeAntenna3 = this._io.readU2be();
            this.sideADeploymentTimeAntenna4 = this._io.readU2be();
            this.sideBAntsTemperature = this._io.readU2be();
            this.sideBAntsDeploymentStatus = this._io.readU2be();
            this.sideBAntsUptime = this._io.readU2be();
            this.sideBDeploymentCountAntenna1 = this._io.readU1();
            this.sideBDeploymentCountAntenna2 = this._io.readU1();
            this.sideBDeploymentCountAntenna3 = this._io.readU1();
            this.sideBDeploymentCountAntenna4 = this._io.readU1();
            this.sideBDeploymentTimeAntenna1 = this._io.readU2be();
            this.sideBDeploymentTimeAntenna2 = this._io.readU2be();
            this.sideBDeploymentTimeAntenna3 = this._io.readU2be();
            this.sideBDeploymentTimeAntenna4 = this._io.readU2be();
        }
        private Integer sideBDeploymentCountAntenna3Raw;
        public Integer sideBDeploymentCountAntenna3Raw() {
            if (this.sideBDeploymentCountAntenna3Raw != null)
                return this.sideBDeploymentCountAntenna3Raw;
            int _tmp = (int) (sideBDeploymentCountAntenna3());
            this.sideBDeploymentCountAntenna3Raw = _tmp;
            return this.sideBDeploymentCountAntenna3Raw;
        }
        private Integer sideBDeploymentTimeAntenna1Raw;
        public Integer sideBDeploymentTimeAntenna1Raw() {
            if (this.sideBDeploymentTimeAntenna1Raw != null)
                return this.sideBDeploymentTimeAntenna1Raw;
            int _tmp = (int) (sideBDeploymentTimeAntenna1());
            this.sideBDeploymentTimeAntenna1Raw = _tmp;
            return this.sideBDeploymentTimeAntenna1Raw;
        }
        private Integer sideADeploymentTimeAntenna3Raw;
        public Integer sideADeploymentTimeAntenna3Raw() {
            if (this.sideADeploymentTimeAntenna3Raw != null)
                return this.sideADeploymentTimeAntenna3Raw;
            int _tmp = (int) (sideADeploymentTimeAntenna3());
            this.sideADeploymentTimeAntenna3Raw = _tmp;
            return this.sideADeploymentTimeAntenna3Raw;
        }
        private Integer sideBDeploymentCountAntenna4Raw;
        public Integer sideBDeploymentCountAntenna4Raw() {
            if (this.sideBDeploymentCountAntenna4Raw != null)
                return this.sideBDeploymentCountAntenna4Raw;
            int _tmp = (int) (sideBDeploymentCountAntenna4());
            this.sideBDeploymentCountAntenna4Raw = _tmp;
            return this.sideBDeploymentCountAntenna4Raw;
        }
        private Integer sideBDeploymentTimeAntenna2Raw;
        public Integer sideBDeploymentTimeAntenna2Raw() {
            if (this.sideBDeploymentTimeAntenna2Raw != null)
                return this.sideBDeploymentTimeAntenna2Raw;
            int _tmp = (int) (sideBDeploymentTimeAntenna2());
            this.sideBDeploymentTimeAntenna2Raw = _tmp;
            return this.sideBDeploymentTimeAntenna2Raw;
        }
        private Integer sideADeploymentCountAntenna3Raw;
        public Integer sideADeploymentCountAntenna3Raw() {
            if (this.sideADeploymentCountAntenna3Raw != null)
                return this.sideADeploymentCountAntenna3Raw;
            int _tmp = (int) (sideADeploymentCountAntenna3());
            this.sideADeploymentCountAntenna3Raw = _tmp;
            return this.sideADeploymentCountAntenna3Raw;
        }
        private Integer sideBDeploymentCountAntenna1Raw;
        public Integer sideBDeploymentCountAntenna1Raw() {
            if (this.sideBDeploymentCountAntenna1Raw != null)
                return this.sideBDeploymentCountAntenna1Raw;
            int _tmp = (int) (sideBDeploymentCountAntenna1());
            this.sideBDeploymentCountAntenna1Raw = _tmp;
            return this.sideBDeploymentCountAntenna1Raw;
        }
        private Integer sideADeploymentCountAntenna4Raw;
        public Integer sideADeploymentCountAntenna4Raw() {
            if (this.sideADeploymentCountAntenna4Raw != null)
                return this.sideADeploymentCountAntenna4Raw;
            int _tmp = (int) (sideADeploymentCountAntenna4());
            this.sideADeploymentCountAntenna4Raw = _tmp;
            return this.sideADeploymentCountAntenna4Raw;
        }
        private Integer sideADeploymentCountAntenna1Raw;
        public Integer sideADeploymentCountAntenna1Raw() {
            if (this.sideADeploymentCountAntenna1Raw != null)
                return this.sideADeploymentCountAntenna1Raw;
            int _tmp = (int) (sideADeploymentCountAntenna1());
            this.sideADeploymentCountAntenna1Raw = _tmp;
            return this.sideADeploymentCountAntenna1Raw;
        }
        private Long sideAAntsUptimeRaw;
        public Long sideAAntsUptimeRaw() {
            if (this.sideAAntsUptimeRaw != null)
                return this.sideAAntsUptimeRaw;
            long _tmp = (long) (sideAAntsUptime());
            this.sideAAntsUptimeRaw = _tmp;
            return this.sideAAntsUptimeRaw;
        }
        private Integer sideBDeploymentTimeAntenna3Raw;
        public Integer sideBDeploymentTimeAntenna3Raw() {
            if (this.sideBDeploymentTimeAntenna3Raw != null)
                return this.sideBDeploymentTimeAntenna3Raw;
            int _tmp = (int) (sideBDeploymentTimeAntenna3());
            this.sideBDeploymentTimeAntenna3Raw = _tmp;
            return this.sideBDeploymentTimeAntenna3Raw;
        }
        private Integer sideBAntsTemperatureRaw;
        public Integer sideBAntsTemperatureRaw() {
            if (this.sideBAntsTemperatureRaw != null)
                return this.sideBAntsTemperatureRaw;
            int _tmp = (int) (sideBAntsTemperature());
            this.sideBAntsTemperatureRaw = _tmp;
            return this.sideBAntsTemperatureRaw;
        }
        private Integer sideADeploymentTimeAntenna2Raw;
        public Integer sideADeploymentTimeAntenna2Raw() {
            if (this.sideADeploymentTimeAntenna2Raw != null)
                return this.sideADeploymentTimeAntenna2Raw;
            int _tmp = (int) (sideADeploymentTimeAntenna2());
            this.sideADeploymentTimeAntenna2Raw = _tmp;
            return this.sideADeploymentTimeAntenna2Raw;
        }
        private Integer sideBDeploymentTimeAntenna4Raw;
        public Integer sideBDeploymentTimeAntenna4Raw() {
            if (this.sideBDeploymentTimeAntenna4Raw != null)
                return this.sideBDeploymentTimeAntenna4Raw;
            int _tmp = (int) (sideBDeploymentTimeAntenna4());
            this.sideBDeploymentTimeAntenna4Raw = _tmp;
            return this.sideBDeploymentTimeAntenna4Raw;
        }
        private Integer sideBAntsDeploymentStatusRaw;
        public Integer sideBAntsDeploymentStatusRaw() {
            if (this.sideBAntsDeploymentStatusRaw != null)
                return this.sideBAntsDeploymentStatusRaw;
            int _tmp = (int) (sideBAntsDeploymentStatus());
            this.sideBAntsDeploymentStatusRaw = _tmp;
            return this.sideBAntsDeploymentStatusRaw;
        }
        private Integer sideADeploymentTimeAntenna1Raw;
        public Integer sideADeploymentTimeAntenna1Raw() {
            if (this.sideADeploymentTimeAntenna1Raw != null)
                return this.sideADeploymentTimeAntenna1Raw;
            int _tmp = (int) (sideADeploymentTimeAntenna1());
            this.sideADeploymentTimeAntenna1Raw = _tmp;
            return this.sideADeploymentTimeAntenna1Raw;
        }
        private Integer sideADeploymentTimeAntenna4Raw;
        public Integer sideADeploymentTimeAntenna4Raw() {
            if (this.sideADeploymentTimeAntenna4Raw != null)
                return this.sideADeploymentTimeAntenna4Raw;
            int _tmp = (int) (sideADeploymentTimeAntenna4());
            this.sideADeploymentTimeAntenna4Raw = _tmp;
            return this.sideADeploymentTimeAntenna4Raw;
        }
        private Integer sideAAntsTemperatureRaw;
        public Integer sideAAntsTemperatureRaw() {
            if (this.sideAAntsTemperatureRaw != null)
                return this.sideAAntsTemperatureRaw;
            int _tmp = (int) (sideAAntsTemperature());
            this.sideAAntsTemperatureRaw = _tmp;
            return this.sideAAntsTemperatureRaw;
        }
        private Integer sideAAntsDeploymentStatusRaw;
        public Integer sideAAntsDeploymentStatusRaw() {
            if (this.sideAAntsDeploymentStatusRaw != null)
                return this.sideAAntsDeploymentStatusRaw;
            int _tmp = (int) (sideAAntsDeploymentStatus());
            this.sideAAntsDeploymentStatusRaw = _tmp;
            return this.sideAAntsDeploymentStatusRaw;
        }
        private Integer sideBDeploymentCountAntenna2Raw;
        public Integer sideBDeploymentCountAntenna2Raw() {
            if (this.sideBDeploymentCountAntenna2Raw != null)
                return this.sideBDeploymentCountAntenna2Raw;
            int _tmp = (int) (sideBDeploymentCountAntenna2());
            this.sideBDeploymentCountAntenna2Raw = _tmp;
            return this.sideBDeploymentCountAntenna2Raw;
        }
        private Integer sideADeploymentCountAntenna2Raw;
        public Integer sideADeploymentCountAntenna2Raw() {
            if (this.sideADeploymentCountAntenna2Raw != null)
                return this.sideADeploymentCountAntenna2Raw;
            int _tmp = (int) (sideADeploymentCountAntenna2());
            this.sideADeploymentCountAntenna2Raw = _tmp;
            return this.sideADeploymentCountAntenna2Raw;
        }
        private Integer sideBAntsUptimeRaw;
        public Integer sideBAntsUptimeRaw() {
            if (this.sideBAntsUptimeRaw != null)
                return this.sideBAntsUptimeRaw;
            int _tmp = (int) (sideBAntsUptime());
            this.sideBAntsUptimeRaw = _tmp;
            return this.sideBAntsUptimeRaw;
        }
        private int sideAAntsTemperature;
        private int sideAAntsDeploymentStatus;
        private long sideAAntsUptime;
        private int sideADeploymentCountAntenna1;
        private int sideADeploymentCountAntenna2;
        private int sideADeploymentCountAntenna3;
        private int sideADeploymentCountAntenna4;
        private int sideADeploymentTimeAntenna1;
        private int sideADeploymentTimeAntenna2;
        private int sideADeploymentTimeAntenna3;
        private int sideADeploymentTimeAntenna4;
        private int sideBAntsTemperature;
        private int sideBAntsDeploymentStatus;
        private int sideBAntsUptime;
        private int sideBDeploymentCountAntenna1;
        private int sideBDeploymentCountAntenna2;
        private int sideBDeploymentCountAntenna3;
        private int sideBDeploymentCountAntenna4;
        private int sideBDeploymentTimeAntenna1;
        private int sideBDeploymentTimeAntenna2;
        private int sideBDeploymentTimeAntenna3;
        private int sideBDeploymentTimeAntenna4;
        private Uvsqsat _root;
        private Uvsqsat.UiFrame _parent;
        public int sideAAntsTemperature() { return sideAAntsTemperature; }
        public int sideAAntsDeploymentStatus() { return sideAAntsDeploymentStatus; }
        public long sideAAntsUptime() { return sideAAntsUptime; }
        public int sideADeploymentCountAntenna1() { return sideADeploymentCountAntenna1; }
        public int sideADeploymentCountAntenna2() { return sideADeploymentCountAntenna2; }
        public int sideADeploymentCountAntenna3() { return sideADeploymentCountAntenna3; }
        public int sideADeploymentCountAntenna4() { return sideADeploymentCountAntenna4; }
        public int sideADeploymentTimeAntenna1() { return sideADeploymentTimeAntenna1; }
        public int sideADeploymentTimeAntenna2() { return sideADeploymentTimeAntenna2; }
        public int sideADeploymentTimeAntenna3() { return sideADeploymentTimeAntenna3; }
        public int sideADeploymentTimeAntenna4() { return sideADeploymentTimeAntenna4; }
        public int sideBAntsTemperature() { return sideBAntsTemperature; }
        public int sideBAntsDeploymentStatus() { return sideBAntsDeploymentStatus; }
        public int sideBAntsUptime() { return sideBAntsUptime; }
        public int sideBDeploymentCountAntenna1() { return sideBDeploymentCountAntenna1; }
        public int sideBDeploymentCountAntenna2() { return sideBDeploymentCountAntenna2; }
        public int sideBDeploymentCountAntenna3() { return sideBDeploymentCountAntenna3; }
        public int sideBDeploymentCountAntenna4() { return sideBDeploymentCountAntenna4; }
        public int sideBDeploymentTimeAntenna1() { return sideBDeploymentTimeAntenna1; }
        public int sideBDeploymentTimeAntenna2() { return sideBDeploymentTimeAntenna2; }
        public int sideBDeploymentTimeAntenna3() { return sideBDeploymentTimeAntenna3; }
        public int sideBDeploymentTimeAntenna4() { return sideBDeploymentTimeAntenna4; }
        public Uvsqsat _root() { return _root; }
        public Uvsqsat.UiFrame _parent() { return _parent; }
    }
    private Ax25Frame ax25Frame;
    private Uvsqsat _root;
    private KaitaiStruct _parent;

    /**
     * @see <a href="https://www.tapr.org/pub_ax25.html">Source</a>
     */
    public Ax25Frame ax25Frame() { return ax25Frame; }
    public Uvsqsat _root() { return _root; }
    public KaitaiStruct _parent() { return _parent; }
}
